' $INCLUDE "RAPIDQ.INC"
$typecheck ON
$INCLUDE "RAPIDQ2.INC"
$INCLUDE <GL\QGL.inc>
$RESOURCE ICO_CARN AS "E:\CARN2\CARN2.ICO"

CONST LF = CHR$(10)

DECLARE SUB FormCreate
DECLARE SUB FormKeyDown (Key AS Word, KeyShift AS INTEGER)
DECLARE SUB FormMouseDown (Button%, X%, Y%, Shift%)
DECLARE SUB FormMouseWheel (Rotation%, X%, Y%, Shift%)
DECLARE SUB FormMouseMove (X%, Y%, Shift%)
DECLARE SUB FormMouseUp(Button%, X%, Y%, Shift%)
DECLARE SUB FormSize
DECLARE SUB FormClose
DECLARE sub meshbuilder
DECLARE sub meshframe(state as integer, ox as integer, nx as integer, oy as integer, ny as integer)
DECLARE sub setrendermode
DECLARE sub setvisual(iw as integer, ih as integer)
DECLARE sub InitMesh
DECLARE sub InitList
DECLARE sub InitGridXY (I AS INTEGER)
DECLARE sub InitGridXZ (I AS INTEGER)
DECLARE sub InitGridYZ (I AS INTEGER)
DECLARE sub ToggleMortal
DECLARE sub ToggleAxes
DECLARE sub ToggleWire
DECLARE sub ToggleTexd
DECLARE sub ToggleOrtho
DECLARE sub TogglePers
DECLARE sub CheckProj
DECLARE SUB ToggleGridXY (Sender AS QMENUITEM)
DECLARE SUB ToggleGridXZ (Sender AS QMENUITEM)
DECLARE SUB ToggleGridYZ (Sender AS QMENUITEM)
DECLARE sub ToggleCyl
DECLARE sub ToggleCirc
DECLARE sub ToggleSphere

DECLARE SUB ObjNumberChange
DECLARE SUB OpenObjForm
DECLARE SUB CloseObjForm

DECLARE SUB SfxNumberChange
DECLARE SUB EditSfxForm
DECLARE SUB CloseSfxForm

DECLARE SUB AnimNumberChange
DECLARE SUB AnimSfxNumberChange
DECLARE SUB EditAnimForm
DECLARE SUB CloseAnimForm

DECLARE SUB TriNumberChange
DECLARE SUB OpenTriForm
DECLARE SUB CloseTriForm
DECLARE SUB SaveTriForm
DECLARE SUB AllTriForm
DECLARE SUB TriFormClose

DECLARE SUB ReInitLists

DECLARE SUB AddToList
DECLARE SUB RemoveFromList
DECLARE SUB ClearList
DECLARE SUB FillList
DECLARE SUB CopyToList

$define PAN    1
$define ROTATE 2
$define ZOOM   3

$define sfDoubleSide         1
$define sfDarkBack           2
$define sfOpacity            4
$define sfTransparent        8
$define sfMortal        &H0010
$define sfPhong         &H0020
$define sfEnvMap        &H0040
$define sfNeedVC        &H0080
$define sfDark          &H8000

$define ofPLACEWATER            1
$define ofPLACEGROUND           2
$define ofPLACEUSER             4
$define ofCIRCLE                8
$define ofBOUND            &H0010
$define ofNOBMP            &H0020
$define ofNOLIGHT          &H0040
$define ofDEFLIGHT         &H0080
$define ofGRNDLIGHT        &H0100
$define ofNOSOFT           &H0200
$define ofNOSOFT2          &H0400
$define ofANIMATED     &H80000000



defint mx,my,dx,dy
dim trans(3) as single
dim rotat(2) as single

DEFINT state = 0

DIM TexBuffer(255,255) AS INTEGER
DIM TexBufferAddr AS LONG
 
DIM myTexture AS GLuint :myTexture = 0
DIM meshList as glInt
DIM trisList as glInt
DIM gridList as glInt
DIM suboList as glInt
DIM cyl as GLUquadricObj
DIM disk as GLUquadricObj
DIM sphere as GLUquadricObj
DIM GL AS QGL
  GL.bpp = 32
    GL.DepthBits = 32
'-- user interface here 

DIM CloseForm AS QMenuItem
    CloseForm.Caption = "&Close"
    CloseForm.OnClick = FormClose
        
DIM ViewMortal AS QMenuItem
    ViewMortal.Caption = "&Mortal spots"
    ViewMortal.OnClick = ToggleMortal
    ViewMortal.Checked = False

DIM ViewSubObjs AS QMenuItem
    ViewSubObjs.Caption = "Sub&objects"
    ViewSubObjs.OnClick = OpenObjForm
    ViewSubObjs.Checked = False

DIM ViewTris AS QMenuItem
    ViewTris.Caption = "&Triangles"
    ViewTris.OnClick = OpenTriForm
    ViewTris.Checked = False

DIM ViewAxes AS QMenuItem
    ViewAxes.Caption = "&Axes"
    ViewAxes.OnClick = ToggleAxes
    ViewAxes.Checked = True

DIM ViewGridXY0 AS QMenuItem
    ViewGridXY0.Caption = "None"
    ViewGridXY0.OnClick = ToggleGridXY
    ViewGridXY0.Checked = True
    ViewGridXY0.RadioItem = True

DIM ViewGridXY1 AS QMenuItem
    ViewGridXY1.Caption = "1 unit steps"
    ViewGridXY1.OnClick = ToggleGridXY
    ViewGridXY1.RadioItem = True

DIM ViewGridXY10 AS QMenuItem
    ViewGridXY10.Caption = "10 unit steps"
    ViewGridXY10.OnClick = ToggleGridXY
    ViewGridXY10.RadioItem = True

DIM ViewGridXY100 AS QMenuItem
    ViewGridXY100.Caption = "100 unit steps"
    ViewGridXY100.OnClick = ToggleGridXY
    ViewGridXY100.RadioItem = True

DIM ViewGridXY AS QMenuItem
    ViewGridXY.Caption = "&XY Plane"
    ViewGridXY.AddItems ViewGridXY0, ViewGridXY1, ViewGridXY10, ViewGridXY100

DIM ViewGridXZ0 AS QMenuItem
    ViewGridXZ0.Caption = "None"
    ViewGridXZ0.OnClick = ToggleGridXZ
    ViewGridXZ0.Checked = True
    ViewGridXZ0.RadioItem = True

DIM ViewGridXZ1 AS QMenuItem
    ViewGridXZ1.Caption = "1 unit steps"
    ViewGridXZ1.OnClick = ToggleGridXZ
    ViewGridXZ1.RadioItem = True

DIM ViewGridXZ10 AS QMenuItem
    ViewGridXZ10.Caption = "10 unit steps"
    ViewGridXZ10.OnClick = ToggleGridXZ
    ViewGridXZ10.RadioItem = True

DIM ViewGridXZ100 AS QMenuItem
    ViewGridXZ100.Caption = "100 unit steps"
    ViewGridXZ100.OnClick = ToggleGridXZ
    ViewGridXZ100.RadioItem = True

DIM ViewGridXZ AS QMenuItem
    ViewGridXZ.Caption = "X&Z Plane"
    ViewGridXZ.AddItems ViewGridXZ0, ViewGridXZ1, ViewGridXZ10, ViewGridXZ100

DIM ViewGridYZ0 AS QMenuItem
    ViewGridYZ0.Caption = "None"
    ViewGridYZ0.OnClick = ToggleGridYZ
    ViewGridYZ0.Checked = True
    ViewGridYZ0.RadioItem = True

DIM ViewGridYZ1 AS QMenuItem
    ViewGridYZ1.Caption = "1 unit steps"
    ViewGridYZ1.OnClick = ToggleGridYZ
    ViewGridYZ1.RadioItem = True

DIM ViewGridYZ10 AS QMenuItem
    ViewGridYZ10.Caption = "10 unit steps"
    ViewGridYZ10.OnClick = ToggleGridYZ
    ViewGridYZ10.RadioItem = True

DIM ViewGridYZ100 AS QMenuItem
    ViewGridYZ100.Caption = "100 unit steps"
    ViewGridYZ100.OnClick = ToggleGridYZ
    ViewGridYZ100.RadioItem = True

DIM ViewGridYZ AS QMenuItem
    ViewGridYZ.Caption = "&YZ Plane"
    ViewGridYZ.AddItems ViewGridYZ0, ViewGridYZ1, ViewGridYZ10, ViewGridYZ100

DIM ViewGrid AS QMenuItem
    ViewGrid.Caption = "Ref. &grids"
    ViewGrid.AddItems ViewGridXY, ViewGridXZ, ViewGridYZ

DIM ViewCyl AS QMenuItem
    ViewCyl.Caption = "Collision &Cylinder"
    ViewCyl.OnClick = ToggleCyl
    ViewCyl.Checked = False
    ViewCyl.Enabled = False

DIM ViewCirc AS QMenuItem
    ViewCirc.Caption = "Ground Ci&rcle"
    ViewCirc.OnClick = ToggleCirc
    ViewCirc.Checked = False
    ViewCirc.Enabled = False

DIM ViewSphere AS QMenuItem
    ViewSphere.Caption = "Bounding &Sphere"
    ViewSphere.OnClick = ToggleSphere
    ViewSphere.Checked = False
    ViewSphere.Enabled = False

DIM ViewWire AS QMenuItem
    ViewWire.Caption = "&Wireframe"
    ViewWire.OnClick = ToggleWire
    ViewWire.RadioItem = True

DIM ViewTexd AS QMenuItem
    ViewTexd.Caption = "&Textured"
    ViewTexd.OnClick = ToggleTexd
    ViewTexd.RadioItem = True
    ViewTexd.Checked = True

DIM ViewRender AS QMenuItem
    ViewRender.Caption = "&Rendering"
    ViewRender.AddItems ViewWire, ViewTexd
    
DIM ViewOrtho AS QMenuItem
    ViewOrtho.Caption = "&Orthographic"
    ViewOrtho.OnClick = ToggleOrtho
    ViewOrtho.RadioItem = True

DIM ViewPers AS QMenuItem
    ViewPers.Caption = "&Perspective"
    ViewPers.OnClick = TogglePers
    ViewPers.RadioItem = True
    ViewPers.Checked = True

DIM ViewProj AS QMenuItem
    ViewProj.Caption = "&Projection"
    ViewProj.AddItems ViewOrtho, ViewPers
    
DIM ViewForm AS QMenuItem
    ViewForm.Caption = "&View"
    ViewForm.AddItems ViewAxes, ViewGrid, ViewTris, ViewMortal, ViewSubObjs, ViewCyl, ViewCirc, ViewSphere, ViewRender' , ViewProj

        
create Form as QFORM'EX
    IcoHandle = ICO_CARN
  caption       = "3D View"
  center
'  width         = 256
  width         = 360
'  height        = 256
    Height = 256+4+18+20+2+22+4
  onresize      = FormSize
  onpaint       = FormSize
'  onpaint       = meshbuilder
'  onshow        = FormCreate
  onshow        = meshbuilder
  onmouseup     = FormMouseUp
  onmousedown   = FormMouseDown
  onmousemove   = FormMouseMove
'  onmousewheel  = FormMouseWheel
  onkeydown     = FormKeyDown
  visible=False
    CREATE FormMenu AS QMainMenu
        AddItems CloseForm, ViewForm
    END CREATE    
end create
' form.showmodal
FormCreate
gridList=glGenLists(3)
	cyl  = gluNewQuadric()
	disk = gluNewQuadric()
	sphere = gluNewQuadric()


Declare Function PlaySound Lib "winmm.dll" Alias "PlaySoundA" (lpszName As long, hModule As Long, dwFlags As Long) As Long

declare sub play (length AS INTEGER, wavdata AS STRING)
declare sub saveWav (fn AS STRING, length AS INTEGER, wavdata AS STRING)
declare sub loadWav (fn AS STRING)

declare SUB SetFocus LIB "USER32" ALIAS "SetFocus" (HWnd AS LONG)

DIM CONTADOR AS INTEGER
DIM X AS INTEGER
DIM Y AS INTEGER
DIM R AS INTEGER
DIM D AS INTEGER
DIM H AS INTEGER
DIM V AS INTEGER
DIM H1 AS INTEGER
DIM V1 AS INTEGER
DIM A1 AS INTEGER
DIM MustWidth% AS INTEGER
DIM MustHeight% AS INTEGER

DIM ObjIndex AS SHORT
DIM TriIndex AS SHORT

dim soundstream as qmemorystream
DIM WavFile AS QFileStream
DIM SaveWavDialog AS QFileDialog
DIM LoadWavDialog AS QOpenDialog
DIM SaveAnimDialog AS QFileDialog
DIM LoadAnimDialog AS QOpenDialog
DIM SaveDialog AS QFileDialog
DIM OpenDialog AS QOpenDialog
  
DECLARE SUB DumpHeaderInfo
DECLARE SUB DumpObjInfo
DECLARE SUB DumpSubObj
DECLARE SUB DumpAnim
DECLARE SUB DumpSfx
DECLARE SUB DumpTable     
DECLARE SUB TextPaint

DECLARE SUB ChangeDirectories
DECLARE SUB ChangeDrive
DECLARE SUB LoadCarFile
DECLARE SUB InitScreen
DECLARE SUB DrawPicture555
DECLARE SUB DrawSprite555
DECLARE SUB ExitClick
DECLARE SUB FileOpen
DECLARE SUB StoreBitmap (Z AS INTEGER)
DECLARE SUB SpriteRGBto555
DECLARE SUB ViewSprite
DECLARE SUB ViewMesh

DECLARE SUB CanvasPaint
DECLARE SUB SpritePaint
DECLARE SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)

DECLARE SUB PlaySfx
DECLARE SUB SaveSfx
DECLARE SUB LoadSfx
DECLARE SUB SelectSound (Sender AS QMENUITEM)
DECLARE SUB SelectSound1 (Sender AS QMENUITEM)
DECLARE SUB SelectSound2 (Sender AS QMENUITEM)
DECLARE SUB SelectSound3 (Sender AS QMENUITEM)

DECLARE SUB PlayAnim
DECLARE SUB SaveAnim
DECLARE SUB LoadAnim
DECLARE SUB SelectAnim (Sender AS QMENUITEM)
DECLARE SUB SelectAnim1 (Sender AS QMENUITEM)
DECLARE SUB SelectAnim2 (Sender AS QMENUITEM)
DECLARE SUB SelectAnim3 (Sender AS QMENUITEM)

DECLARE SUB ExportTGA (Image AS INTEGER)
DECLARE SUB ImportTGA (Image AS INTEGER)
DECLARE SUB LoadTGA (Image AS INTEGER)
DECLARE SUB SaveTGA (Image AS INTEGER)

DECLARE SUB ExportBMP16 (Image AS INTEGER)
DECLARE SUB ImportBMP16 (Image AS INTEGER)
DECLARE SUB LoadBMP16 (Image AS INTEGER)
DECLARE SUB SaveBMP16 (Image AS INTEGER)

DECLARE SUB ExportBMP32 (Image AS INTEGER)
DECLARE SUB ImportBMP32 (Image AS INTEGER)
DECLARE SUB LoadBMP32 (Image AS INTEGER)
DECLARE SUB SaveBMP32 (Image AS INTEGER)

DECLARE SUB ExportJPG (Image AS INTEGER)
DECLARE SUB ImportJPG (Image AS INTEGER)
DECLARE SUB LoadJPG (Image AS INTEGER)
DECLARE SUB SaveJPG (Image AS INTEGER)

DECLARE SUB ExportTGA_0
DECLARE SUB ImportTGA_0

DECLARE SUB ExportBMP16_0
DECLARE SUB ImportBMP16_0

DECLARE SUB ExportBMP32_0
DECLARE SUB ImportBMP32_0

DECLARE SUB ExportJPG_0
DECLARE SUB ImportJPG_0

DECLARE SUB ExportTGA_1
DECLARE SUB ImportTGA_1

DECLARE SUB ExportBMP16_1
DECLARE SUB ImportBMP16_1

DECLARE SUB ExportBMP32_1
DECLARE SUB ImportBMP32_1

DECLARE SUB ExportJPG_1
DECLARE SUB ImportJPG_1

DECLARE SUB RGBto555

DECLARE SUB FileSave
DECLARE SUB SaveCarFile

DECLARE SUB File3dfExport
DECLARE SUB Save3dfFile

DECLARE SUB FileMdfExport
DECLARE SUB SaveMdfFile

TYPE CAR_Face
	v1 AS INTEGER
	v2 AS INTEGER
	v3 AS INTEGER
	tax AS INTEGER
	tbx AS INTEGER
	tcx AS INTEGER
	tay AS INTEGER
	tby AS INTEGER
	tcy AS INTEGER
	Flags AS WORD
	DMask AS WORD
	Distant AS INTEGER
	FaceNext AS INTEGER
	group AS INTEGER
	reserv AS STRING * 12
END TYPE

TYPE CAR_Point3d
	x AS SINGLE
	y AS SINGLE
	z AS SINGLE
	owner AS SHORT
	hide AS SHORT
END TYPE

TYPE 3DF_Obj
	objName AS STRING * 32
	ox AS SINGLE
	oy AS SINGLE
	oz AS SINGLE
	owner AS SHORT
	hide AS SHORT
END TYPE

TYPE CAR_Animation
	aniName AS STRING * 32
	aniKPS AS INTEGER
	FramesCount AS INTEGER
	AniTime AS INTEGER
'      AniDataString AS STRING * 64*1024*3*2
'	aniData(63,1023,2) AS SHORT
END TYPE

TYPE CAR_AniFrame
        aniVerts(1023,2) AS SHORT
END TYPE

TYPE CAR_AniVert
        x AS SHORT
        y AS SHORT
        z AS SHORT
END TYPE

TYPE CAR_SoundFX
	sfxName AS STRING * 32
	length AS INTEGER
	lpData AS STRING * 1024*1024
END TYPE

TYPE OBJ_Info
	Radius AS INTEGER
	YLo AS INTEGER
	YHi AS INTEGER
	lineLength AS INTEGER
	lIntensity AS INTEGER
	circleRad AS INTEGER
	cIntensity AS INTEGER
	Flags AS INTEGER
	GrRad AS INTEGER
	DefLight AS INTEGER
	LastAniTime AS INTEGER
	BoundR AS SINGLE
	reserv AS STRING * 16
END TYPE


DIM TMPaniName AS STRING * 32
DIM TMPaniKPS AS INTEGER
DIM TMPFramesCount AS INTEGER
DIM TMPAniTime AS INTEGER
'DIM TMPaniData(63,1023,2) AS SHORT
'MEMSET(VARPTR(TMPaniData(0,0,0)),0,64*1024*3*SIZEOF(SHORT))
DIM TMPaniData AS STRING * 1024*3*2
DIM TMPaniVert AS CAR_AniVert
DIM TMPaniCoord AS SHORT
'DIM TMPaniFrame AS CAR_AniFrame
DIM ObjInfo as OBJ_Info

DIM TMPsfxName AS STRING * 32
DIM TMPlength AS INTEGER
DIM TMPlpData AS STRING * 1024*1024
DIM TMPsfxTime AS INTEGER

DIM AnimList(63) AS CAR_Animation
'DIM AnimFrames(64,64) AS CAR_AniFrame
'DIM AnimVerts(64,64,1024) AS CAR_AniVert
DIM AnimData(63,63,1023,2) AS SHORT
MEMSET(VARPTR(AnimData(0,0,0,0)),0,64*64*1024*3*SIZEOF(SHORT))
DIM PointList(1023) AS CAR_Point3d
DIM FaceList(1023) AS CAR_Face
DIM ObjList(63) AS 3DF_Obj
DIM SoundList(63) AS CAR_SoundFX
DIM Texture(255,255) AS WORD
DIM Sprite(127,127) AS WORD
DIM AniFX(63) AS INTEGER
DIM ModelName AS STRING * 32
DIM AniCount AS INTEGER, SfxCount AS INTEGER, VCount AS INTEGER, FCount AS INTEGER, OCount AS INTEGER, TextureSize AS INTEGER, TextureHeight AS INTEGER
DIM TMPvCount AS INTEGER, TMPvCount1 AS INTEGER, TMPvCount2 AS INTEGER
DIM FileType AS INTEGER
DIM AnimIndex AS INTEGER, SfxIndex AS INTEGER

DIM DummyObj AS 3df_Obj
	DummyObj.objName = "Object0"+CHR$(0)
	DummyObj.ox = 0
	DummyObj.oy = 0
	DummyObj.oz = 0
	DummyObj.owner = -1
	DummyObj.hide = 0


DIM CurrentType AS INTEGER
DIM CurrentName$ as String

DIM DumpStream AS QMemoryStream
DIM DumpText$ as String * 128
DIM DumpSize AS INTEGER
DIM DumpLines AS INTEGER

DIM A1& AS INTEGER

DIM List1(1023) AS INTEGER, Index1 AS INTEGER
DIM List2(1023) AS INTEGER, Index2 AS INTEGER
DIM List3(1023) AS INTEGER, Index3 AS INTEGER
DIM List4(1023) AS INTEGER, Index4 AS INTEGER
DIM List5(1023) AS INTEGER, Index5 AS INTEGER
DIM List6(1023) AS INTEGER, Index6 AS INTEGER
DIM List7(1023) AS INTEGER, Index7 AS INTEGER
DIM SubObjList(63,1023) AS INTEGER, SubObjIndex(63) AS INTEGER
DIM TriList(1023) AS BYTE
DIM TriListAddr AS LONG
TriListAddr=VARPTR(TriList(0))
MEMSET(TriListAddr,0,1024*SIZEOF(BYTE))


DIM BitMap AS QBITMAPEX
    BitMap.Width = 256
    BitMap.Height = 256
'    BitMap.PixelFormat = pf24Bit
    BitMap.PixelFormat = pf32bit
'    BitMap.Transparent = True
'    BitMap.TransparentColor = 0
'    BitMap.TransparentMode = tmAlpha
    BitMap.Paint(0,0,0,0)    

DIM SpriteBitMap AS QBITMAP
    SpriteBitMap.Width = 128
        SpriteBitMap.Height = 128
    SpriteBitMap.Paint(0,0,0,0)    

DIM XBitMap AS QBITMAPex
    XBitMap.Width = 256
    XBitMap.Height = 256
    XBitMap.PixelFormat = pf32bit
    XBitMap.Paint(0,0,0,0)    

DIM TextureList AS QBITMAP
    TextureList.Width = 256
    TextureList.Height = 256
    TextureList.Paint(0,0,0,0)    
    
DIM Font AS QFont
    Font.Name = "Arial"
    Font.Size = 12
    Font.Color = &H00FF00

DIM TEX??(127,127)
DIM FileName$ as String
DIM Q AS SHORT
DIM ROJO AS BYTE
DIM VERDE AS BYTE
DIM AZUL AS BYTE

DIM ChngDrv AS QMenuItem
    ChngDrv.Caption = "Change &Drive"
    ChngDrv.OnClick = ChangeDrive  

DIM OpenFile AS QMenuItem
    OpenFile.Caption = "&Open File"
    OpenFile.OnClick = FileOpen  

DIM SaveFile AS QMenuItem
    SaveFile.Caption = "&Save File"
    SaveFile.OnClick = FileSave  
    SaveFile.Enabled = False  

DIM ExitPrg AS QMenuItem
    ExitPrg.Caption = "E&xit"
    ExitPrg.OnClick = ExitClick
            
DIM ExportMesh3df AS QMenuItem
    ExportMesh3df.Caption = "as .3df"
    ExportMesh3df.OnClick = File3dfExport

DIM ExportMeshMdf AS QMenuItem
    ExportMeshMdf.Caption = "as .mdf"
    ExportMeshMdf.OnClick = FileMdfExport
    
DIM ExportMesh AS QMenuItem
    ExportMesh.Caption = "&Export mesh"
    ExportMesh.AddItems ExportMesh3df, ExportMeshMdf
    ExportMesh.Enabled = False  

            
DIM FileMenu AS QMenuItem
    FileMenu.Caption = "&File"
    FileMenu.AddItems OpenFile, SaveFile, ExportMesh, ExitPrg
     
DIM ShowHeader AS QMenuItem
    ShowHeader.Caption = "&Header info"
    ShowHeader.Enabled=True
    ShowHeader.OnClick=DumpHeaderInfo

DIM ShowObj AS QMenuItem
    ShowObj.Caption = "&Object info"
    ShowObj.Enabled=False
    ShowObj.OnClick=DumpObjInfo

DIM ShowSubList AS QMenuItem
    ShowSubList.Caption = "S&ubobject list"
    ShowSubList.Enabled=False
    ShowSubList.OnClick=DumpSubObj

DIM ShowAnimList AS QMenuItem
    ShowAnimList.Caption = "&Animation list"
    ShowAnimList.Enabled=False
    ShowAnimList.OnClick=DumpAnim

DIM ShowSfxList AS QMenuItem
    ShowSfxList.Caption = "&Sound list"
    ShowSfxList.Enabled=False
    ShowSfxList.OnClick=DumpSfx

DIM ShowTable AS QMenuItem
    ShowTable.Caption = "Sfx/Anim &table"
    ShowTable.Enabled=False
    ShowTable.OnClick=DumpTable

DIM ShowSprite AS QMenuItem
    ShowSprite.Caption = "S&prite"
    ShowSprite.Enabled=False
    ShowSprite.OnClick=ViewSprite

DIM ShowMesh AS QMenuItem
    ShowMesh.Caption = "&Mesh"
    ShowMesh.Enabled=True
    ShowMesh.OnClick=ViewMesh

DIM ShowMenu AS QMenuItem
    ShowMenu.Caption = "S&how"
    ShowMenu.Enabled=False
    ShowMenu.AddItems ShowHeader, ShowObj, ShowSubList, ShowAnimList, ShowSfxList, ShowTable, ShowSprite, ShowMesh


DIM SaveAsTGA AS QMenuItem
    SaveAsTGA.Caption = "as 16-bit TGA"
    SaveAsTGA.OnClick = ExportTGA_1
    SaveAsTGA.Enabled=True
    
DIM LoadFromTGA AS QMenuItem
    LoadFromTGA.Caption = "from 16-bit TGA"
    LoadFromTGA.OnClick = ImportTGA_1
    LoadFromTGA.Enabled=True


DIM SaveAsBMP16 AS QMenuItem
    SaveAsBMP16.Caption = "as 16-bit BMP"
    SaveAsBMP16.OnClick = ExportBMP16_1
    SaveAsBMP16.Enabled=True
    
DIM LoadFromBMP16 AS QMenuItem
    LoadFromBMP16.Caption = "from 16-bit BMP"
    LoadFromBMP16.OnClick = ImportBMP16_1
    LoadFromBMP16.Enabled=True
    

DIM SaveAsBMP32 AS QMenuItem
    SaveAsBMP32.Caption = "as 32-bit BMP"
    SaveAsBMP32.OnClick = ExportBMP32_1
    SaveAsBMP32.Enabled=True

DIM LoadFromBMP32 AS QMenuItem
    LoadFromBMP32.Caption = "from 24/32-bit BMP"
    LoadFromBMP32.OnClick = ImportBMP32_1
    LoadFromBMP32.Enabled=True


DIM LoadFromVarious AS QMenuItem
    LoadFromVarious.Caption = "from image file"
    LoadFromVarious.OnClick = ImportJPG_1
    LoadFromVarious.Enabled=(NViewLibPresent>0)


DIM SaveAsJPG AS QMenuItem
    SaveAsJPG.Caption = "as JPEG"
    SaveAsJPG.OnClick = ExportJPG_1
    SaveAsJPG.Enabled=(NViewLibPresent AND 1)


DIM SaveTexture AS QMenuItem
    SaveTexture.Caption = "&Save"
    SaveTexture.Enabled=True
    SaveTexture.AddItems SaveAsTGA, SaveAsBMP16, SaveAsBMP32, SaveAsJPG

    
DIM LoadTexture AS QMenuItem
    LoadTexture.Caption = "&Replace"
    LoadTexture.Enabled=True
    LoadTexture.AddItems LoadFromTGA, LoadFromBMP16, LoadFromBMP32, LoadFromVarious


DIM TextureMenu AS QMenuItem
    TextureMenu.Caption = "Te&xture"
    TextureMenu.Enabled=False
    TextureMenu.AddItems SaveTexture, LoadTexture


DIM SaveSpriteAsTGA AS QMenuItem
    SaveSpriteAsTGA.Caption = "as 16-bit TGA"
    SaveSpriteAsTGA.OnClick = ExportTGA_0
    SaveSpriteAsTGA.Enabled=True
    
DIM LoadSpriteFromTGA AS QMenuItem
    LoadSpriteFromTGA.Caption = "from 16-bit TGA"
    LoadSpriteFromTGA.OnClick = ImportTGA_0
    LoadSpriteFromTGA.Enabled=True


DIM SaveSpriteAsBMP16 AS QMenuItem
    SaveSpriteAsBMP16.Caption = "as 16-bit BMP"
    SaveSpriteAsBMP16.OnClick = ExportBMP16_0
    SaveSpriteAsBMP16.Enabled=True
    
DIM LoadSpriteFromBMP16 AS QMenuItem
    LoadSpriteFromBMP16.Caption = "from 16-bit BMP"
    LoadSpriteFromBMP16.OnClick = importBMP16_0
    LoadSpriteFromBMP16.Enabled=True
    

DIM SaveSpriteAsBMP32 AS QMenuItem
    SaveSpriteAsBMP32.Caption = "as 32-bit BMP"
    SaveSpriteAsBMP32.OnClick = ExportBMP32_0
    SaveSpriteAsBMP32.Enabled=True

DIM LoadSpriteFromBMP32 AS QMenuItem
    LoadSpriteFromBMP32.Caption = "from 24/32-bit BMP"
    LoadSpriteFromBMP32.OnClick = ImportBMP32_0
    LoadSpriteFromBMP32.Enabled=True


DIM LoadSpriteFromVarious AS QMenuItem
    LoadSpriteFromVarious.Caption = "from image file"
    LoadSpriteFromVarious.OnClick = ImportJPG_0
    LoadSpriteFromVarious.Enabled=(NViewLibPresent>0)


DIM SaveSpriteAsJPG AS QMenuItem
    SaveSpriteAsJPG.Caption = "as JPEG"
    SaveSpriteAsJPG.OnClick = ExportJPG_0
    SaveSpriteAsJPG.Enabled=(NViewLibPresent AND 1)


DIM SaveSprite AS QMenuItem
    SaveSprite.Caption = "&Save"
    SaveSprite.Enabled=True
    SaveSprite.AddItems SaveSpriteAsTGA, SaveSpriteAsBMP16, SaveSpriteAsBMP32, SaveSpriteAsJPG

    
DIM LoadSprite AS QMenuItem
    LoadSprite.Caption = "&Replace"
    LoadSprite.Enabled=True
    LoadSprite.AddItems LoadSpriteFromTGA, LoadSpriteFromBMP16, LoadSpriteFromBMP32, LoadSpriteFromVarious


DIM SpriteMenu AS QMenuItem
    SpriteMenu.Caption = "S&prite"
    SpriteMenu.Enabled=True
    SpriteMenu.AddItems SaveSprite, LoadSprite


DIM SfxSelect AS QMenuItem
    SfxSelect.Caption = "&Select"
    SfxSelect.Enabled=False

DIM SfxPlay AS QMenuItem
    SfxPlay.Caption = "Re&play"
    SfxPlay.Enabled=False
    SfxPlay.OnClick = PlaySfx  
        
DIM SfxSave AS QMenuItem
    SfxSave.Caption = "Sa&ve"
    SfxSave.Enabled=False
    SfxSave.OnClick = SaveSfx  

DIM SfxLoad AS QMenuItem
    SfxLoad.Caption = "&Replace"
    SfxLoad.Enabled=False
        SfxLoad.OnClick = LoadSfx  

              

DIM SfxMenu AS QMenuItem
    SfxMenu.Caption = "So&unds"
    SfxMenu.Enabled=False
    SfxMenu.OnClick = EditSfxForm

DIM AnimMenu AS QMenuItem
    AnimMenu.Caption = "&Animations"
    AnimMenu.Enabled=False
    AnimMenu.OnClick = EditAnimForm

DIM MoreAnim1 AS QMenuItem
    MoreAnim1.Caption = "&More..."
DIM MoreAnim2 AS QMenuItem
    MoreAnim2.Caption = "&More..."
DIM MoreAnim3 AS QMenuItem
    MoreAnim3.Caption = "&More..."
    
DIM AnimListMenu(64) AS QMENUITEM
FOR CONTADOR=0 TO 63
      AnimListMenu(CONTADOR).Caption = "Animation " + STR$(CONTADOR)
      AnimListMenu(CONTADOR).OnClick = SelectAnim3
      IF CONTADOR<48 THEN AnimListMenu(CONTADOR).OnClick = SelectAnim2
      IF CONTADOR<32 THEN AnimListMenu(CONTADOR).OnClick = SelectAnim1
      IF CONTADOR<16 THEN AnimListMenu(CONTADOR).OnClick = SelectAnim
NEXT CONTADOR
    
CREATE Form1 AS QForm
    IcoHandle = ICO_CARN
    Height = 256+4+18+20+2+22+4
    Width = 256+4+4
    BorderStyle = 2
    Caption="Carnivores 1/2/Ice Age .car/.3df File/.rsc Object Editor - (C) 2008 by M.A.Ch.F."
CREATE MainMenu AS QMainMenu
    AddItems FileMenu, ShowMenu, TextureMenu, SfxMenu, AnimMenu
    END CREATE    
CREATE Canvas AS QCanvas
    Width = 256
    Height = 256
    ClientWidth = 256
    ClientHeight = 256
    Visible = True
    Visible = False
    OnPaint = CanvasPaint
    OnMouseMove=CanvasMouseMove
END CREATE
CREATE Status1 AS QStatusBar
    Enabled = True
    Height = 24
    SimplePanel = True
END CREATE
CREATE TextPopUp AS QForm
    IcoHandle = ICO_CARN
    Height = 200
    Width = 200
    BorderStyle = 3
    CREATE TextCanvas AS QCanvas
        Visible = True
        OnPaint = TextPaint
        Width=200
        Height=200
    END CREATE
    WindowState=0
    Visible=False
    Center
END CREATE
CREATE SpritePopUp AS QForm
    CREATE PopUpMenu AS QMainMenu
        AddItems SpriteMenu
    END CREATE    
    Parent=Form1
    IcoHandle = ICO_CARN
    Height = 128+4+18+20+4
    Width = 128+4+4
'    Height = 200
'    Width = 200
    BorderStyle = 2
    CREATE SpriteCanvas AS QCanvas
        Visible = True
        OnPaint = SpritePaint
        Width=128
                Height=128
        ClientWidth=128
        ClientHeight=128
    END CREATE
    WindowState=0
    Visible=False
END CREATE
CREATE ObjForm AS QForm
    Parent=Form1
    IcoHandle = ICO_CARN
    BorderStyle = 3
  Height = 160
  Width = 300
  CREATE ObjLabelSel AS QLabel
    Left = 10
    Top = 22
    Caption = "SubObj:"
  END CREATE
    CREATE ObjLabelNum0 AS QLabel
    Left = 270
        Top = 22
    Caption = "0"
  END CREATE
  CREATE ObjScrollSelect AS QScrollBar
    Left = 50
    Top = 20
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Object Index"
    OnChange = ObjNumberChange
  END CREATE
  CREATE SubObjNameLabel AS QLabel
    Left = 10
    Top = 52
    Caption = "Name:"
  END CREATE
  CREATE SubObjNameValue AS QLabel
    Left = 50
        Top = 52
    Caption = ""
  END CREATE
  CREATE SubObjCenterLabel AS QLabel
    Left = 10
    Top = 82
    Caption = "Center:"
  END CREATE
  CREATE SubObjCenterValue AS QLabel
    Left = 50
        Top = 82
    Caption = ""
  END CREATE
  CREATE SubObjOwnerLabel AS QLabel
    Left = 10
    Top = 112
    Caption = "Owner:"
  END CREATE
  CREATE SubObjOwnerValue AS QLabel
    Left = 50
        Top = 112
    Caption = ""
  END CREATE
  CREATE SubObjHideLabel AS QLabel
    Left = 110
    Top = 112
    Caption = "Hide:"
  END CREATE
  CREATE SubObjHideValue AS QLabel
    Left = 150
    Top = 112
    Caption = ""
  END CREATE
  Caption = "SubObjects"
  onClose = CloseObjForm
    WindowState=0
    Visible=False
END CREATE

CREATE TriForm AS QForm
    Parent=Form1
    IcoHandle = ICO_CARN
    BorderStyle = 3
  Height = 320
  Width = 300
  CREATE TriLabelSel AS QLabel
    Left = 10
    Top = 22
    Caption = "Triangle:"
  END CREATE
    CREATE TriLabelNum0 AS QLabel
    Left = 270
        Top = 22
    Caption = "0"
  END CREATE
  CREATE TriScrollSelect AS QScrollBar
    Left = 50
    Top = 20
    Width = 200
    Height = 20
    Min = 0: Max = 1023
    ShowHint =  True
    Hint = "Triangle Index"
    OnChange = TriNumberChange
  END CREATE
  CREATE TriDMaskLabel AS QLabel
    Left = 10
    Top = 52
    Caption = "DMask:"
  END CREATE
  CREATE TriDMaskValue AS QLabel
    Left = 50
        Top = 52
    Caption = ""
  END CREATE
  CREATE TriDistantLabel AS QLabel
    Left = 80
    Top = 52
    Caption = "Distant:"
  END CREATE
  CREATE TriDistantValue AS QLabel
    Left = 120
        Top = 52
    Caption = ""
  END CREATE
  CREATE TriNextLabel AS QLabel
    Left = 150
    Top = 52
    Caption = "Next:"
  END CREATE
  CREATE TriNextValue AS QLabel
    Left = 190
        Top = 52
    Caption = ""
  END CREATE
  CREATE TriGroupLabel AS QLabel
    Left = 220
    Top = 52
    Caption = "Group:"
  END CREATE
  CREATE TriGroupValue AS QLabel
    Left = 260
    Top = 52
    Caption = ""
  END CREATE
  CREATE TriDoubleSide AS QCheckBox
    Left = 10
    Top = 82
    Caption = "sfDoubleSide"
    Checked = False
    ShowHint =  True
    Hint = "Can be seen both from the front and back"
  END CREATE
  CREATE TriDarkBack AS QCheckBox
    Left = 110
    Top = 82
    Caption = "sfDarkBack"
    Checked = False
    ShowHint =  True
    Hint = "Back side is unlit?"
  END CREATE
  CREATE TriOpacity AS QCheckBox
    Left = 210
    Top = 82
    Caption = "sfOpacity"
    Checked = False
    ShowHint =  True
    Hint = "Non-zero color values are opaque, zero (black) are transparent"
  END CREATE
  CREATE TriTransparent AS QCheckBox
    Left = 10
    Top = 112
    Caption = "sfTransparent"
    Checked = False
    ShowHint =  True
    Hint = "Triangle uses alpha channel transparency"
  END CREATE
  CREATE TriMortal AS QCheckBox
    Left = 110
    Top = 112
    Caption = "sfMortal"
    Checked = False
    ShowHint =  True
    Hint = "In dinos, a hit here kills"
  END CREATE
  CREATE TriPhong AS QCheckBox
    Left = 210
    Top = 112
    Caption = "sfPhong"
    Checked = False
    ShowHint =  True
    Hint = "In weapons, triangle has Phong mapping"
  END CREATE
  CREATE TriEnvMap AS QCheckBox
    Left = 10
    Top = 142
    Caption = "sfEnvMap"
    Checked = False
    ShowHint =  True
    Hint = "In weapons, triangle has Environmental mapping"
  END CREATE
  CREATE TriNeedVC AS QCheckBox
    Left = 110
    Top = 142
    Caption = "sfNeedVC"
    Checked = False
    ShowHint =  True
    Hint = "Triangle need vertex culling?"
  END CREATE
  CREATE TriDark AS QCheckBox
    Left = 210
    Top = 142
    Caption = "sfDark"
    Checked = False
    ShowHint =  True
    Hint = "Triangle is unlit?"
  END CREATE
CREATE SaveTri AS QButton
  Parent = TriForm
  Left = 20
  Top = 170
  Width = 110
  Caption = "Apply"
  OnClick = SaveTriForm
    ShowHint =  True
    Hint = "Apply flags to currently selected triangle"
END CREATE
CREATE AllTri AS QButton
  Parent = TriForm
  Left = 160
  Top = 170
  Width = 110
  Caption = "Apply to all"
  OnClick = AllTriForm
    ShowHint =  True
    Hint = "Apply flags to all triangles in the mesh"
END CREATE
CREATE AddTri AS QButton
  Parent = TriForm
  Left = 20
  Top = 200
  Width = 110
  Caption = "Add to list"
  OnClick = AddToList
    ShowHint =  True
    Hint = "Add selected triangle to batch list"
END CREATE
CREATE RemoveTri AS QButton
  Parent = TriForm
  Left = 160
  Top = 200
  Width = 110
  Caption = "Remove from list"
  OnClick = RemoveFromList
    ShowHint =  True
    Hint = "Remove selected triangle from batch list"
END CREATE
CREATE FillTri AS QButton
  Parent = TriForm
  Left = 20
  Top = 230
  Width = 110
  Caption = "Fill list"
  OnClick = FillList
    ShowHint =  True
    Hint = "Add all triangles to batch list"
END CREATE
CREATE ClearTri AS QButton
  Parent = TriForm
  Left = 160
  Top = 230
  Width = 110
  Caption = "Clear list"
  OnClick = ClearList
    ShowHint =  True
    Hint = "Remove all triangles from batch list"
END CREATE
CREATE CopyTri AS QButton
  Parent = TriForm
  Left = 20
  Top = 260
  Width = 110
  Caption = "Copy to list"
  OnClick = CopyToList
    ShowHint =  True
    Hint = "Copy flags from selected triangle to all triangles in batch list (apply any changes first)"
END CREATE
CREATE CloseTri AS QButton
  Parent = TriForm
  Left = 160
  Top = 260
  Width = 110
  Caption = "Close"
  OnClick = TriFormClose
    ShowHint =  True
    Hint = "Close this dialog"
END CREATE
  Caption = "Triangles"
  onClose = CloseTriForm
    WindowState=0
    Visible=False
END CREATE

CREATE SfxForm AS QForm
'    IcoHandle = ICO_CARN
    BorderStyle = 3
  Height = 160
  Width = 300
  CREATE SfxLabelSel AS QLabel
    Left = 10
    Top = 22
    Caption = "Sfx:"
  END CREATE
    CREATE SfxLabelNum0 AS QLabel
    Left = 270
    Top = 22
    Caption = "0"
  END CREATE
    CREATE SfxLabelName AS QLabel
    Left = 70
    Top = 40
    Caption = " "

  END CREATE
  CREATE SfxScrollSelect AS QScrollBar
    Left = 50
    Top = 20
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Sound Index"
    OnChange = SfxNumberChange
  END CREATE
CREATE SaveSfxB AS QButton
  Parent = SfxForm
  Left = 20
  Top = 60
  Width = 110
  Caption = "Save as WAV"
  OnClick = SaveSfx
END CREATE
CREATE LoadSfxB AS QButton
  Parent = SfxForm
  Left = 160
  Top = 60
  Width = 110
  Caption = "Replace from WAV"
  OnClick = LoadSfx
END CREATE
CREATE PlaySfxB AS QButton
  Parent = SfxForm
  Left = 20
  Top = 100
  Width = 110
  Caption = "Play Sound"
  OnClick = PlaySfx
END CREATE
CREATE CloseSfx AS QButton
  Parent = SfxForm
  Left = 160
  Top = 100
  Width = 110
  Caption = "Close"
  OnClick = CloseSfxForm
END CREATE
  Caption = "Sounds"
    WindowState=0
    Visible=False
END CREATE


CREATE AnimForm AS QForm
'    IcoHandle = ICO_CARN
    BorderStyle = 3
  Height = 200
  Width = 300
  CREATE AnimLabelSel AS QLabel
    Left = 10
    Top = 22
    Caption = "Anim:"
  END CREATE
  CREATE AnimLabelNum0 AS QLabel
    Left = 270
    Top = 22
    Caption = "0"
  END CREATE
    CREATE AnimLabelName AS QLabel
    Left = 70
    Top = 40
    Caption = " "
  END CREATE
  CREATE AnimScrollSelect AS QScrollBar
    Left = 50
    Top = 20
    Width = 200
    Height = 20
    Min = 0: Max = 255
    ShowHint =  True
    Hint = "Animation Index"
    OnChange = AnimNumberChange
  END CREATE
CREATE SaveAnimB AS QButton
  Parent = AnimForm
  Left = 20
  Top = 60
  Width = 110
  Caption = "Save as VTL"
  OnClick = SaveAnim
END CREATE
CREATE LoadAnimB AS QButton
  Parent = AnimForm
  Left = 160
  Top = 60
  Width = 110
  Caption = "Replace from VTL"
  OnClick = LoadAnim
END CREATE
CREATE PlayAnimB AS QButton
  Parent = AnimForm
  Left = 20
  Top = 100
  Width = 110
  Caption = "Play Animation"
  ' OnClick = PlayAnim
END CREATE
CREATE CloseAnim AS QButton
  Parent = AnimForm
  Left = 160
  Top = 100
  Width = 110
  Caption = "Close"
  OnClick = CloseAnimForm
END CREATE
  CREATE AnimSfxScrollSelect AS QScrollBar
    Left = 50
    Top = 140
    Width = 200
    Height = 20
    Min = -1: Max = 63
    ShowHint =  True
    Hint = "Associated SFX"
    OnChange = AnimSfxNumberChange
  END CREATE
  CREATE AnimSFXLabelSel AS QLabel
    Left = 10
    Top = 142
    Caption = "SFX:"
  END CREATE
  CREATE AnimSFXLabelNum0 AS QLabel
    Left = 270
    Top = 142
    Caption = "0"
  END CREATE
    CREATE AnimSFXLabelName AS QLabel
    Left = 70
    Top = 160
    Caption = " "

  END CREATE
  Caption = "Animations"
    WindowState=0
    Visible=False
END CREATE



    Center
  ShowModal
END CREATE




$typecheck OFF

SUB InitGridXY (I AS INTEGER)
glNewList(gridList,GL_COMPILE)
FOR X=-10 TO 9
glBegin(GL_QUAD_STRIP)
FOR Y=-10 TO 10
glVertex3f(-X*I,Y*I,0)
glVertex3f(-(X+1)*I,Y*I,0)
NEXT Y
glEnd
NEXT X
glEndList
END SUB

SUB InitGridXZ (I AS INTEGER)
glNewList(gridList+1,GL_COMPILE)
FOR X=-10 TO 9
glBegin(GL_QUAD_STRIP)
FOR Z=-10 TO 10
glVertex3f(-X*I,0,Z*I)
glVertex3f(-(X+1)*I,0,Z*I)
NEXT Z
glEnd
NEXT X
glEndList
END SUB

SUB InitGridYZ (I AS INTEGER)
glNewList(gridList+2,GL_COMPILE)
FOR Y=-10 TO 9
glBegin(GL_QUAD_STRIP)
FOR Z=-10 TO 10
glVertex3f(0,Y*I,Z*I)
glVertex3f(0,(Y+1)*I,Z*I)
NEXT Z
glEnd
NEXT Y
glEndList
END SUB

SUB InitList
     trisList=glGenLists(1)
     glNewList(trisList,GL_COMPILE)
     glBegin(GL_TRIANGLES)
 FOR A1=0 TO FCount -1
 IF TriList(A1) = 1 THEN
     glColor4f(1.0, 1.0, 0.0, 0.75)
     glVertex3f(-PointList(FaceList(A1).v1).x,PointList(FaceList(A1).v1).y,PointList(FaceList(A1).v1).z)
     glColor4f(1.0, 1.0, 0.0, 0.75)
     glVertex3f(-PointList(FaceList(A1).v2).x,PointList(FaceList(A1).v2).y,PointList(FaceList(A1).v2).z)
     glColor4f(1.0, 1.0, 0.0, 0.75)
     glVertex3f(-PointList(FaceList(A1).v3).x,PointList(FaceList(A1).v3).y,PointList(FaceList(A1).v3).z)
 END IF     
 NEXT A1    
    glEnd
    glEndList
END SUB

SUB InitMesh
'    BitMap.PixelFormat = pf24Bit
	myTexture = GL.CreateTextureFromBitmap(BitMap)   	'load texture, put id in myTexture 
'    BitMap.PixelFormat = pf32Bit
    IF myTexture = 0 THEN form.Close
 	glBindTexture GL_TEXTURE_2D, myTexture                 '' Select new Texture if needed 

'    glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT)
'        glClearColor(0.5,0.5,0.5,0.0)
''TexBufferAddr=VARPTR(TexBuffer(0,0))
''glGenTextures 1, myTexture
'glBindTexture GL_TEXTURE_2D, myTexture
''     glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT)
''     glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT)

''        glTexParameteri GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST      'GL_LINEAR is smoother but slower
''        glTexParameteri GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST
''glTexImage2D(GL_TEXTURE_2D, 0, 4, 256, TextureHeight, 0, GL_RGBA, GL_UNSIGNED_BYE, TexBufferAddr)
        
DIM I AS INTEGER
DIM V1 AS INTEGER, V2 AS INTEGER, V3 AS INTEGER

 DIM TAX AS SINGLE, TAY AS SINGLE
 DIM TBX AS SINGLE, TBY AS SINGLE
 DIM TCX AS SINGLE, TCY AS SINGLE

      meshList=glGenLists(8)
      glNewList(meshList,GL_COMPILE)
glBegin(GL_POINTS)
 glColor3f(1.0,1.0,1.0)
 glVertex3f(0,0,0)
glEnd
 
glBegin(GL_LINES)
 glColor3f(1.0,0.0,0.0)
glVertex3f(-100,0,0)
glVertex3f(0,0,0)
 glColor3f(0.0,1.0,0.0)
glVertex3f(0,100,0)
glVertex3f(0,0,0)
 glColor3f(0.0,0.0,1.0)
glVertex3f(0,0,100)
glVertex3f(0,0,0)
glEnd
glEndList

      glNewList(meshList+7,GL_COMPILE)
     glBegin(GL_TRIANGLES)
 FOR I=0 TO Index7 -1
 V1=FaceList(List7(I)).v1
 V2=FaceList(List7(I)).v2
 V3=FaceList(List7(I)).v3
     glColor4f(1.0, 0.0, 0.0, 0.75)
     glVertex3f(-PointList(V1).x,PointList(V1).y,PointList(V1).z)
     glColor4f(1.0, 0.0, 0.0, 0.75)
          glVertex3f(-PointList(V2).x,PointList(V2).y,PointList(V2).z)
     glColor4f(1.0, 0.0, 0.0, 0.75)
     glVertex3f(-PointList(V3).x,PointList(V3).y,PointList(V3).z)
 NEXT I    
    glEnd
    glEndList

suboList=glGenLists(OCount)

FOR A1=0 TO OCount -1
      glNewList(suboList+A1,GL_COMPILE)
IF CurrentType>1 THEN
glBegin(GL_POINTS)
 glColor4f(0.0,0.0,1.0,1.0)
 glVertex3f(-ObjList(A1).ox,ObjList(A1).oy,ObjList(A1).oz)
glEnd
END IF
  glBegin(GL_TRIANGLES)
 FOR I=0 TO SubObjIndex(A1) -1
 V1=FaceList(SubObjList(A1,I)).v1
 V2=FaceList(SubObjList(A1,I)).v2
 V3=FaceList(SubObjList(A1,I)).v3
     glColor4f(0.0, 1.0, 0.0, 0.5)
     glVertex3f(-PointList(V1).x,PointList(V1).y,PointList(V1).z)
     glColor4f(0.0, 1.0, 0.0, 0.5)
     glVertex3f(-PointList(V2).x,PointList(V2).y,PointList(V2).z)
     glColor4f(0.0, 1.0, 0.0, 0.5)
     glVertex3f(-PointList(V3).x,PointList(V3).y,PointList(V3).z)
 NEXT I    
    glEnd
    glEndList
NEXT A1

      glNewList(meshList+1,GL_COMPILE)
     glBegin(GL_TRIANGLES)
 FOR I=0 TO Index1 -1
 V1=FaceList(List1(I)).v1
 V2=FaceList(List1(I)).v2
 V3=FaceList(List1(I)).v3
 TAX= FaceList(List1(I)).tax :TAX=TAX/256
 TAY= FaceList(List1(I)).tay :TAY=1-TAY/256
 TBX= FaceList(List1(I)).tbx :TBX=TBX/256
 TBY= FaceList(List1(I)).tby :TBY=1-TBY/256
 TCX= FaceList(List1(I)).tcx :TCX=TCX/256
 TCY= FaceList(List1(I)).tcy :TCY=1-TCY/256
     glTexCoord2f (TAX,TAY)
     glColor4f(1.0, 1.0, 1.0, 0.5)
     glVertex3f(-PointList(V1).x,PointList(V1).y,PointList(V1).z)
     glTexCoord2f (TBX,TBY)
     glColor4f(1.0, 1.0, 1.0, 0.5)
     glVertex3f(-PointList(V2).x,PointList(V2).y,PointList(V2).z)
     glTexCoord2f (TCX,TCY)
     glColor4f(1.0, 1.0, 1.0, 0.5)
     glVertex3f(-PointList(V3).x,PointList(V3).y,PointList(V3).z)

 NEXT I    
    glEnd
    glEndList
    
      glNewList(meshList+4,GL_COMPILE)
     glBegin(GL_TRIANGLES)
 FOR I=0 TO Index4 -1
 V1=FaceList(List4(I)).v1
 V2=FaceList(List4(I)).v2
 V3=FaceList(List4(I)).v3
 TAX= FaceList(List4(I)).tax :TAX=TAX/256
 TAY= FaceList(List4(I)).tay :TAY=1-TAY/256
 TBX= FaceList(List4(I)).tbx :TBX=TBX/256
 TBY= FaceList(List4(I)).tby :TBY=1-TBY/256
 TCX= FaceList(List4(I)).tcx :TCX=TCX/256
 TCY= FaceList(List4(I)).tcy :TCY=1-TCY/256
     glTexCoord2f (TAX,TAY)
     glColor4f(1.0, 1.0, 1.0, 0.5)
     glVertex3f(-PointList(V1).x,PointList(V1).y,PointList(V1).z)
     glTexCoord2f (TBX,TBY)
     glColor4f(1.0, 1.0, 1.0, 0.5)
     glVertex3f(-PointList(V2).x,PointList(V2).y,PointList(V2).z)
     glTexCoord2f (TCX,TCY)
     glColor4f(1.0, 1.0, 1.0, 0.5)
     glVertex3f(-PointList(V3).x,PointList(V3).y,PointList(V3).z)

 NEXT I    
    glEnd
    glEndList
    
      glNewList(meshList+2,GL_COMPILE)
     glBegin(GL_TRIANGLES)
 FOR I=0 TO Index2 -1
 V1=FaceList(List2(I)).v1
 V2=FaceList(List2(I)).v2
 V3=FaceList(List2(I)).v3
 TAX= FaceList(List2(I)).tax :TAX=TAX/256
 TAY= FaceList(List2(I)).tay :TAY=1-TAY/256
 TBX= FaceList(List2(I)).tbx :TBX=TBX/256
 TBY= FaceList(List2(I)).tby :TBY=1-TBY/256
 TCX= FaceList(List2(I)).tcx :TCX=TCX/256
 TCY= FaceList(List2(I)).tcy :TCY=1-TCY/256
     glTexCoord2f (TAX,TAY)
     glColor4f(1.0, 1.0, 1.0, 1.0)
     glVertex3f(-PointList(V1).x,PointList(V1).y,PointList(V1).z)
     glTexCoord2f (TBX,TBY)
     glColor4f(1.0, 1.0, 1.0, 1.0)
     glVertex3f(-PointList(V2).x,PointList(V2).y,PointList(V2).z)
     glTexCoord2f (TCX,TCY)
     glColor4f(1.0, 1.0, 1.0, 1.0)
     glVertex3f(-PointList(V3).x,PointList(V3).y,PointList(V3).z)

 NEXT I    
    glEnd
    glEndList
    
      glNewList(meshList+5,GL_COMPILE)
     glBegin(GL_TRIANGLES)
 FOR I=0 TO Index5 -1
 V1=FaceList(List5(I)).v1
 V2=FaceList(List5(I)).v2
 V3=FaceList(List5(I)).v3
 TAX= FaceList(List5(I)).tax :TAX=TAX/256
 TAY= FaceList(List5(I)).tay :TAY=1-TAY/256
 TBX= FaceList(List5(I)).tbx :TBX=TBX/256
 TBY= FaceList(List5(I)).tby :TBY=1-TBY/256
 TCX= FaceList(List5(I)).tcx :TCX=TCX/256
 TCY= FaceList(List5(I)).tcy :TCY=1-TCY/256
     glTexCoord2f (TAX,TAY)
     glColor4f(1.0, 1.0, 1.0, 1.0)
     glVertex3f(-PointList(V1).x,PointList(V1).y,PointList(V1).z)
     glTexCoord2f (TBX,TBY)
     glColor4f(1.0, 1.0, 1.0, 1.0)
     glVertex3f(-PointList(V2).x,PointList(V2).y,PointList(V2).z)
     glTexCoord2f (TCX,TCY)
     glColor4f(1.0, 1.0, 1.0, 1.0)
     glVertex3f(-PointList(V3).x,PointList(V3).y,PointList(V3).z)

 NEXT I    
    glEnd
    glEndList
    
      glNewList(meshList+3,GL_COMPILE)
     glBegin(GL_TRIANGLES)
 FOR I=0 TO Index3 -1
 V1=FaceList(List3(I)).v1
 V2=FaceList(List3(I)).v2
 V3=FaceList(List3(I)).v3
 TAX= FaceList(List3(I)).tax :TAX=TAX/256
 TAY= FaceList(List3(I)).tay :TAY=1-TAY/256
 TBX= FaceList(List3(I)).tbx :TBX=TBX/256
 TBY= FaceList(List3(I)).tby :TBY=1-TBY/256
 TCX= FaceList(List3(I)).tcx :TCX=TCX/256
 TCY= FaceList(List3(I)).tcy :TCY=1-TCY/256
     glTexCoord2f (TAX,TAY)
     glColor4f(1.0, 1.0, 1.0, 1.0)
     glVertex3f(-PointList(V1).x,PointList(V1).y,PointList(V1).z)
     glTexCoord2f (TBX,TBY)
     glColor4f(1.0, 1.0, 1.0, 1.0)
     glVertex3f(-PointList(V2).x,PointList(V2).y,PointList(V2).z)
     glTexCoord2f (TCX,TCY)
     glColor4f(1.0, 1.0, 1.0, 1.0)
     glVertex3f(-PointList(V3).x,PointList(V3).y,PointList(V3).z)

 NEXT I    
    glEnd
    glEndList
    
      glNewList(meshList+6,GL_COMPILE)
     glBegin(GL_TRIANGLES)
 FOR I=0 TO Index6 -1
 V1=FaceList(List6(I)).v1
 V2=FaceList(List6(I)).v2
 V3=FaceList(List6(I)).v3
 TAX= FaceList(List6(I)).tax :TAX=TAX/256
 TAY= FaceList(List6(I)).tay :TAY=1-TAY/256
 TBX= FaceList(List6(I)).tbx :TBX=TBX/256
 TBY= FaceList(List6(I)).tby :TBY=1-TBY/256
 TCX= FaceList(List6(I)).tcx :TCX=TCX/256
 TCY= FaceList(List6(I)).tcy :TCY=1-TCY/256
     glTexCoord2f (TAX,TAY)
     glColor4f(1.0, 1.0, 1.0, 1.0)
     glVertex3f(-PointList(V1).x,PointList(V1).y,PointList(V1).z)
     glTexCoord2f (TBX,TBY)
     glColor4f(1.0, 1.0, 1.0, 1.0)
     glVertex3f(-PointList(V2).x,PointList(V2).y,PointList(V2).z)
     glTexCoord2f (TCX,TCY)
     glColor4f(1.0, 1.0, 1.0, 1.0)
     glVertex3f(-PointList(V3).x,PointList(V3).y,PointList(V3).z)

 NEXT I    
    glEnd
    glEndList

END SUB


SUB SpritePaint
    SpriteCanvas.Draw(0,0, SpriteBitmap.BMP)
    SpriteCanvas.Visible=True
    SpritePopUp.ShowModal
END SUB

SUB DrawSprite555
FOR X = 0 TO 127
FOR Y = 0 TO 127

R = Sprite(X, Y)

D=R

ROJO=INT((D AND &H7C00)/&H400)
VERDE=INT((D AND &H03E0)/&H20)
AZUL=INT(D AND &H001F)

D=(AZUL*&H80000+VERDE*&H800+ROJO*8)

H = Y: V = X
H1 = Y + 1: V1 = X + 1
SpriteBitMap.Rectangle(H, V, H1, V1, D)

NEXT Y: NEXT X
END SUB

SUB SpriteRGBto555

FOR X = 0 TO 127
FOR Y = 0 TO 127

R = SpriteBitMap.Pixel(Y, X)

D=R

ROJO=INT((D AND &HF8)/8)
VERDE=INT((D AND &HF800)/&H800)
AZUL=(INT(D AND &HF80000)/&H80000)

D=(AZUL+VERDE*&H20+ROJO*&H400)

Sprite(X, Y) = D

NEXT Y: NEXT X

END SUB


SUB ViewSprite
'    DrawSprite555
    SpritePopUp.Left=Form1.Left+264
    SpritePopUp.Top=Form1.Top
    SpritePopUp.Visible=True
    SpritePopUp.Show
END SUB

SUB TextPaint
    DumpStream.Position=0
    FOR A1&=1 to DumpLines
    DumpText$=DumpStream.ReadLine
    TextCanvas.TextOut(8, 16*A1&, DumpText$, 0, -1)
    NEXT A1&
END SUB

SUB DumpHeaderInfo
    TextPopUp.Close
    TextPopUp.Width=200
    TextPopUp.Height=200
    TextCanvas.Width=200
    TextCanvas.Height=200
    DumpStream.close
    DumpStream.Position=0
    IF CurrentType=1 THEN
        DumpText$="Model Name: "+LEFT$(ModelName, INSTR(ModelName, CHR$(0)) -1)
        DumpStream.WriteLine(DumpText$)
        DumpStream.WriteLine("Animations: "+STR$(AniCount))
        DumpStream.WriteLine("Sound FX: "+STR$(SfxCount))
    END IF
    DumpStream.WriteLine("Vertices: "+STR$(VCount))
    DumpStream.WriteLine("Faces: "+STR$(FCount))
    ' IF CurrentType>1 THEN 
    DumpStream.WriteLine("SubObjects: "+STR$(OCount))
    DumpText$="Texture size: "+STR$(TextureSize)+" Bytes"
    DumpStream.WriteLine(DumpText$)
    DumpText$="(256x"+STR$(TextureSize/512)+" pixels)"
    DumpStream.WriteLine(DumpText$)
    DumpSize=DumpStream.Size
    DumpLines=DumpStream.LineCount
    TextPopUp.Caption="Header Info"
    TextPopUp.Visible=True
    TextPopUp.Show
END SUB

SUB DumpObjInfo
    TextPopUp.Close
    TextPopUp.Width=200
    TextPopUp.Height=432
    TextCanvas.Width=200
    TextCanvas.Height=432
    DumpStream.close
    DumpStream.Position=0
    DumpStream.WriteLine("Collision Cylinder Radius: "+STR$(ObjInfo.Radius))
    DumpStream.WriteLine("Collision Cylinder Bottom: "+STR$(ObjInfo.YLo))
    DumpStream.WriteLine("Collision Cylinder Top: "+STR$(ObjInfo.YHi))
    DumpStream.WriteLine("Shadow line length: "+STR$(ObjInfo.linelength))
    DumpStream.WriteLine("Shadow line intensity: "+STR$(ObjInfo.lintensity))
    DumpStream.WriteLine("Shadow circle radius: "+STR$(ObjInfo.circlerad))
    DumpStream.WriteLine("Shadow circle intensity: "+STR$(ObjInfo.cintensity))
    DumpStream.WriteLine("Ground Radius: "+STR$(ObjInfo.GrRad))
    DumpStream.WriteLine("Default Light: "+STR$(ObjInfo.DefLight))
    DumpStream.WriteLine("Last Animation Frame Time: "+STR$(ObjInfo.LastAniTime))
    DumpStream.WriteLine("Bounding Sphere Radius: "+STR$(ObjInfo.BoundR))
    DumpStream.WriteLine("Object Flags Value: "+STR$(ObjInfo.Flags))
    DumpStream.WriteLine("ofPlaceWater: "+STR$(SGN(ObjInfo.Flags AND ofPlaceWater)))
    DumpStream.WriteLine("ofPlaceGround: "+STR$(SGN(ObjInfo.Flags AND ofPlaceGround)))
    DumpStream.WriteLine("ofPlaceUser: "+STR$(SGN(ObjInfo.Flags AND ofPlaceUser)))
    DumpStream.WriteLine("ofCircle: "+STR$(SGN(ObjInfo.Flags AND ofCircle)))
    DumpStream.WriteLine("ofBound: "+STR$(SGN(ObjInfo.Flags AND ofBound)))
    DumpStream.WriteLine("ofNoBMP: "+STR$(SGN(ObjInfo.Flags AND ofNoBMP)))
    DumpStream.WriteLine("ofNoLight: "+STR$(SGN(ObjInfo.Flags AND ofNoLight)))
    DumpStream.WriteLine("ofDefLight: "+STR$(SGN(ObjInfo.Flags AND ofDefLight)))
    DumpStream.WriteLine("ofGrndLight: "+STR$(SGN(ObjInfo.Flags AND ofGrndLight)))
    DumpStream.WriteLine("ofNoSoft: "+STR$(SGN(ObjInfo.Flags AND ofNosoft)))
    DumpStream.WriteLine("ofNoSoft2: "+STR$(SGN(ObjInfo.Flags AND ofNosoft2)))
    DumpStream.WriteLine("ofAnimated: "+STR$(SGN(ObjInfo.Flags AND ofAnimated)))
    DumpSize=DumpStream.Size
    DumpLines=DumpStream.LineCount
    TextPopUp.Caption="Object Info"
    TextPopUp.Visible=True
    TextPopUp.Show
END SUB

SUB DumpSubObj
DIM TMPobjName AS STRING * 32
DIM TMPx AS SINGLE, TMPy AS SINGLE, TMPz AS SINGLE
DIM TMPowner AS SHORT, TMPhide AS SHORT
    TextPopUp.Close
    TextPopUp.Width=300
    TextPopUp.Height=OCount*64+64
    TextCanvas.Width=300
    TextCanvas.Height=OCount*64+64
    DumpStream.close
    DumpStream.Position=0
    FOR A1 = 0 TO OCount-1
        DumpStream.WriteLine("SubObject #"+STR$(A1))
        TMPobjName=ObjList(A1).objName
        DumpText$="  Name: "+ LEFT$(TMPobjName, INSTR(TMPobjName, CHR$(0)) -1)
        DumpStream.WriteLine(DumpText$)
        TMPx=ObjList(A1).ox
        TMPy=ObjList(A1).oy
        TMPz=ObjList(A1).oz
        DumpText$="  Center: "+ STR$(TMPx)+", "+STR$(TMPy)+", "+STR$(TMPz)
        DumpStream.WriteLine(DumpText$)
        TMPowner=ObjList(A1).owner
        TMPhide=ObjList(A1).hide
        DumpText$="  Owner: "+STR$(TMPowner)+"  Hide: "+STR$(TMPhide)
        DumpStream.WriteLine(DumpText$)
    NEXT A1
    DumpSize=DumpStream.Size
    DumpLines=DumpStream.LineCount
        TextPopUp.Caption="SubObject Info"
    TextPopUp.Visible=True
    TextPopUp.Show
END SUB

SUB DumpAnim
    TextPopUp.Close
    TextPopUp.Width=200
    TextPopUp.Height=AniCount*48+64
    TextCanvas.Width=200
    TextCanvas.Height=AniCount*48+64
    DumpStream.close
    DumpStream.Position=0
    FOR A1 = 0 TO AniCount-1
        DumpStream.WriteLine("Animation #"+STR$(A1))
        TMPaniName=AnimList(A1).aniName
        TMPaniKPS=AnimList(A1).aniKPS
        DumpText$="  Name: "+ LEFT$(TMPaniName, INSTR(TMPaniName, CHR$(0)) -1)+"  KPS: "+STR$(TMPaniKPS)
        DumpStream.WriteLine(DumpText$)
        TMPFramesCount=AnimList(A1).FramesCount
        TMPaniTime=AnimList(A1).aniTime
        DumpText$="  Frames: "+STR$(TMPFramesCount)+"  Time: "+STR$(TMPaniTime)+"ms"
        DumpStream.WriteLine(DumpText$)
    NEXT A1
    DumpSize=DumpStream.Size
    DumpLines=DumpStream.LineCount
    TextPopUp.Caption="Animation Info"
    TextPopUp.Visible=True
    TextPopUp.Show
END SUB

SUB DumpSfx
    TextPopUp.Close
    TextPopUp.Width=200
    TextPopUp.Height=SfxCount*48+64
    TextCanvas.Width=200
    TextCanvas.Height=SfxCount*48+64
    DumpStream.close
    DumpStream.Position=0
    FOR A1 = 0 TO SfxCount-1
        DumpStream.WriteLine("Sound #"+STR$(A1))
        TMPsfxName=SoundList(A1).sfxName
        TMPlength=SoundList(A1).length
        DumpText$="  Name: "+ LEFT$(TMPsfxName, INSTR(TMPsfxName, CHR$(0)) -1)
        DumpStream.WriteLine(DumpText$)
        TMPsfxTime=TMPlength/44.1
        DumpText$="  Length: "+STR$(TMPlength)+ " bytes"+"  Time: "+STR$(TMPsfxTime)+"ms"
        DumpStream.WriteLine(DumpText$)
    NEXT A1
    DumpSize=DumpStream.Size
    DumpLines=DumpStream.LineCount
    TextPopUp.Caption="Sound Info"
    TextPopUp.Visible=True
    TextPopUp.Show
END SUB

SUB DumpTable     
    TextPopUp.Close
    TextPopUp.Width=200
    TextPopUp.Height=AniCount*16+64
    TextCanvas.Width=200
    TextCanvas.Height=AniCount*16+64
    DumpStream.close
    DumpStream.Position=0
    FOR A1 = 0 TO AniCount-1
        IF AniFX(A1)> -1 THEN
            DumpText$="Animation #"+STR$(A1)+": Sound #"+STR$(AniFX(A1))
        ELSE
            DumpText$="Animation #"+STR$(A1)+": No sound"
        END IF
        DumpStream.WriteLine(DumpText$)
    NEXT A1
    DumpSize=DumpStream.Size
    DumpLines=DumpStream.LineCount
    TextPopUp.Caption="Sound Assignment"
    TextPopUp.Visible=True
    TextPopUp.Show
END SUB

SUB PlaySfx
    TMPsfxName=SoundList(SfxIndex).sfxName
    TMPlength=SoundList(SfxIndex).length
    TMPlpData=SoundList(SfxIndex).lpData
    Status1.SimpleText="Playing sound "+STR$(SfxIndex)+": "+TMPsfxName
    play (TMPlength, TMPlpData)
END SUB

SUB SaveSfx
    TMPsfxName=SoundList(SfxIndex).sfxName
    TMPlength=SoundList(SfxIndex).length
    TMPlpData=SoundList(SfxIndex).lpData

  SaveWavDialog.InitialDir = CurDir$
  SaveWavDialog.Mode=fdSave
  SaveWavDialog.WarnIfOverwrite=1
  SaveWavDialog.FileName=TMPsfxName
  SaveWavDialog.Filter = "WAV Files (*.wav)|*.wav"

  IF SaveWavDialog.Execute THEN
    FileName$=SaveWavDialog.FileName
  IF INSTR(FileName$,".wav") = 0 THEN FileName$=FileName$+".wav"
'    Status1.SimpleText="Saving "+FileName$
    saveWav(FileName$, TMPlength, TMPlpData)
    Status1.SimpleText="Saved sound "+STR$(SfxIndex)+" as "+FileName$
   END IF
'    play (TMPlength, TMPlpData)
END SUB

SUB LoadSfx

  LoadWavDialog.InitialDir = CurDir$
  LoadWavDialog.Filter = "WAV Files (*.wav)|*.wav"

    IF LoadWavDialog.Execute THEN
        FileName$=LoadWavDialog.FileName
        TMPsfxName=MID$(FileName$,RINSTR(FileName$,"\")+1,RINSTR(LCASE$(FileName$),".wav")-1-RINSTR(FileName$,"\"))+CHR$(0)
 '    Status1.SimpleText="Saving "+FileName$
    loadWav(FileName$)
'        Status1.SimpleText="Replaced sound "+STR$(SfxIndex)+": "+TMPsfxName
    END IF
'    play (TMPlength, TMPlpData)
END SUB


SUB SaveAnim
    TMPaniName=AnimList(AnimIndex).aniName
    TMPaniKPS=AnimList(AnimIndex).aniKPS

  SaveAnimDialog.InitialDir = CurDir$
  SaveAnimDialog.Mode=fdSave
  SaveAnimDialog.WarnIfOverwrite=1
  SaveAnimDialog.FileName=TMPaniName
  SaveAnimDialog.Filter = "Vertex Table Files (*.vtl)|*.vtl"

  IF SaveAnimDialog.Execute THEN
    FileName$=SaveAnimDialog.FileName
  IF INSTR(FileName$,".vtl") = 0 THEN FileName$=FileName$+".vtl"

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Status1.SimpleText="Writing Animation: "+STR$(AnimIndex)
Form1.Show
Status1.SimpleText="Writing Header Data..."
Form1.Show
File.Write(VCount)
File.Write(TMPaniKPS)
Status1.SimpleText="Animation "+STR$(AnimIndex)+" KPS: "+STR$(TMPaniKPS)
Form1.Show
TMPFramesCount=AnimList(AnimIndex).FramesCount
 IF CurrentType>2 THEN TMPFramesCount++
 File.Write(TMPFramesCount)
Status1.SimpleText="Animation "+STR$(AnimIndex)+" Frames: "+STR$(TMPFramesCount)
Form1.Show
 FOR Frame=1 to TMPFramesCount
  FOR Vertex=1 TO VCount
   FOR Coord=1 TO 3
    TMPaniCoord=AnimData(AnimIndex,Frame-1,Vertex-1,Coord-1)
    File.Write(TMPaniCoord)
   NEXT Coord
  NEXT Vertex
 NEXT Frame
File.Close

    Status1.SimpleText="Saved animation "+STR$(AnimIndex)+" as "+FileName$
   END IF
   END SUB

SUB LoadAnim

  LoadAnimDialog.InitialDir = CurDir$
  LoadAnimDialog.Filter = "Vertex Table Files (*.vtl)|*.vtl"

    IF LoadAnimDialog.Execute THEN
        FileName$=LoadAnimDialog.FileName
        TMPaniName=MID$(FileName$,RINSTR(FileName$,"\")+1,RINSTR(LCASE$(FileName$),".vtl")-1-RINSTR(FileName$,"\"))+CHR$(0)
 '    Status1.SimpleText="Saving "+FileName$


DIM File AS QFileStream
File.Open(FileName$, fmOpenRead)
Status1.SimpleText="Reading Animation: "+STR$(AnimIndex)
Form1.Show
Status1.SimpleText="Animation "+STR$(AnimIndex)+" Name: "+TMPaniName
Form1.Show
Status1.SimpleText="Reading Header Data..."
Form1.Show
File.Read(TMPVCount)
IF TMPVCount=VCount THEN

AnimList(AnimIndex).aniName=TMPaniName
File.Read(TMPaniKPS)
AnimList(AnimIndex).aniKPS=TMPaniKPS
Status1.SimpleText="Animation "+STR$(AnimIndex)+" KPS: "+STR$(TMPaniKPS)
Form1.Show
File.Read(TMPFramesCount)
Status1.SimpleText="Animation "+STR$(AnimIndex)+" Frames: "+STR$(TMPFramesCount)
Form1.Show
TMPaniTime=TMPFramesCount*1000/TMPaniKPS
AnimList(AnimIndex).aniTime=TMPaniTime
 FOR Frame=1 to TMPFramesCount
  FOR Vertex=1 TO VCount
   FOR Coord=1 TO 3
    File.Read(TMPaniCoord)
    AnimData(AnimIndex,Frame-1,Vertex-1,Coord-1)=TMPaniCoord
   NEXT Coord
'  Status1.SimpleText="Data "+STR$(A1)+","+STR$(Frame)+","+STR$(Vertex)+"="+STR$(AnimData(AnimIndex,Frame-1,Vertex-1,0))+","+STR$(AnimData(AnimIndex,Frame-1,Vertex-1,1))+","+STR$(AnimData(AnimIndex,Frame-1,Vertex-1,2))
  NEXT Vertex
 NEXT Frame
 IF CurrentType>2 THEN TMPFramesCount--
AnimList(AnimIndex).FramesCount=TMPFramesCount

             Status1.SimpleText="Replaced animation "+STR$(AnimIndex)+": "+TMPaniName

ELSE
    SHOWMESSAGE "Vertex count mismatch, should be "+STR$(VCount)+" but is "+STR$(TMPVCount)+" -  aborted."
END IF
File.Close
END IF

 
END SUB




SUB SelectAnim (Sender AS QMENUITEM)
    AnimIndex=Sender.MenuIndex
    Sender.RadioItem = True
    Sender.Checked=1
END SUB

SUB SelectAnim1 (Sender AS QMENUITEM)
    AnimIndex=Sender.MenuIndex+16
    Sender.RadioItem = True
    Sender.Checked=1
END SUB

SUB SelectAnim2 (Sender AS QMENUITEM)
    AnimIndex=Sender.MenuIndex+32
    Sender.RadioItem = True
    Sender.Checked=1
END SUB

SUB SelectAnim3 (Sender AS QMENUITEM)
    AnimIndex=Sender.MenuIndex+48
    Sender.RadioItem = True
    Sender.Checked=1
END SUB


SUB ImportTGA (Image AS INTEGER)

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "TGA Files (*.tga)|*.tga"

  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadTGA (Image)

      END IF
END SUB

SUB ExportTGA (Image AS INTEGER)

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "TGA Files (*.tga)|*.tga"
  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".tga") = 0 THEN FileName$=FileName$+".tga"
    Status1.SimpleText="Exporting "+FileName$
    SaveTGA (Image)
      END IF
END SUB

SUB LoadTGA (Image AS INTEGER)

SELECT CASE Image
CASE 0
MustWidth%=128
MustHeight%=128
TextureSize=32768
CASE 1
MustWidth%=256
MustHeight%=TextureHeight
TextureSize=MustWidth%*MustHeight%*2
CASE ELSE
GOTO AbortLoadTGA
END SELECT

DIM File AS QFileStream
File.Open(FileName$, fmOpenRead)
IF File.Size<>18+TextureSize THEN SHOWMESSAGE "WARNING: Not an uncompressed "+STR$(MustWidth%)+"x"+STR$(MustHeight%)+" 16-bit TGA 1.0 image!" ':GOTO AbortLoadTGA

Status1.SimpleText="Reading Header..."
Form1.Show
File.Read(TGAidentsize?)
IF TGAidentsize?<>0 THEN SHOWMESSAGE "ID field present.":GOTO AbortLoadTGA
File.Read(TGAcolourmaptype?)
IF TGAcolourmaptype?<>0 THEN SHOWMESSAGE "Wrong colour map type.":GOTO AbortLoadTGA
File.Read(TGAimagetype?)
IF TGAimagetype?<>2 THEN SHOWMESSAGE "Not an RGB image.":GOTO AbortLoadTGA
File.Read(TGAcolourmapstart%)
IF TGAcolourmapstart%<>0 THEN SHOWMESSAGE "First palette entry should be set to 0.":GOTO AbortLoadTGA
File.Read(TGAcolourmaplength%)
IF TGAcolourmaplength%<>0 THEN SHOWMESSAGE "Colour map present.":GOTO AbortLoadTGA
File.Read(TGAcolourmapbits?)
IF TGAcolourmapbits?<>0 THEN SHOWMESSAGE "Should be 0 bits per palette entry.":GOTO AbortLoadTGA
File.Read(TGAxstart%)
IF TGAxstart%<>0 THEN SHOWMESSAGE "X origin should be 0.":GOTO AbortLoadTGA
File.Read(TGAystart%)
IF TGAystart%<>0 THEN SHOWMESSAGE "Y origin should be 0.":GOTO AbortLoadTGA
File.Read(TGAwidth%)
IF TGAwidth%<>MustWidth% THEN SHOWMESSAGE "Image isn't "+STR$(MustWidth%)+" pixels wide.":GOTO AbortLoadTGA
File.Read(TGAheight%)
IF TGAheight%<>MustHeight% THEN SHOWMESSAGE "Image isn't "+STR$(MustHeight%)+" pixels tall.":GOTO AbortLoadTGA
File.Read(TGAbits?)
IF TGAbits?<>16 THEN SHOWMESSAGE "Not a 16-bit image.":GOTO AbortLoadTGA
File.Read(TGAdescriptor?)
IF TGAdescriptor?<>0 THEN SHOWMESSAGE "Image is flipped or has alpha bits set.":GOTO AbortLoadTGA
Status1.SimpleText="Reading scanlines..."
Form1.Show

SELECT CASE Image
CASE 0
FOR X = 0 TO 127
File.LoadArray(Sprite(128 -X -1, 0),128)
NEXT X
DrawSprite555
Status1.SimpleText="Done"
Form1.Show
SpriteCanvas.Repaint

CASE 1
FOR X = 0 TO TextureHeight -1
File.LoadArray(Texture(TextureHeight -X -1, 0),256)
NEXT X
InitScreen
StoreBitmap(0)
'    BitMap.PixelFormat = pf24Bit
    BitMap.Height = 256
	myTexture = GL.CreateTextureFromBitmap(BitMap)   	'load texture, put id in myTexture 
'    BitMap.PixelFormat = pf32Bit
 meshbuilder

END SELECT

Status1.SimpleText="Done"
AbortLoadTGA:
Form1.Show
File.Close



END SUB

SUB SaveTGA (Image AS INTEGER)

SELECT CASE Image
CASE 0
MustWidth%=128
MustHeight%=128
CASE 1
MustWidth%=256
MustHeight%=TextureHeight
END SELECT

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Status1.SimpleText="Writing Header..."
Form1.Show
TGAidentsize?=0:File.Write(TGAidentsize?)
TGAcolourmaptype?=0:File.Write(TGAcolourmaptype?)
TGAimagetype?=2:File.Write(TGAimagetype?)
TGAcolourmapstart%=0:File.Write(TGAcolourmapstart%)
TGAcolourmaplength%=0:File.Write(TGAcolourmaplength%)
TGAcolourmapbits?=0:File.Write(TGAcolourmapbits?)
TGAxstart%=0:File.Write(TGAxstart%)
TGAystart%=0:File.Write(TGAystart%)
TGAwidth%=MustWidth%:File.Write(TGAwidth%)
TGAheight%=MustHeight%:File.Write(TGAheight%)
TGAbits?=16:File.Write(TGAbits?)
TGAdescriptor?=0:File.Write(TGAdescriptor?)
Status1.SimpleText="Writing scanlines..."
Form1.Show

SELECT CASE Image

CASE 0
FOR X = 0 TO 127
File.SaveArray(Sprite(128 -X -1, 0),128)
NEXT X

CASE 1
FOR X = 0 TO TextureHeight -1
File.SaveArray(Texture(TextureHeight -X -1, 0),256)
NEXT X

END SELECT

Status1.SimpleText="Done"
Form1.Show
File.Close

END SUB

SUB ExportBMP16 (Image AS INTEGER)

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "BMP Files (*.bmp)|*.bmp"
  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".bmp") = 0 THEN FileName$=FileName$+".bmp"
    Status1.SimpleText="Exporting "+FileName$
    SaveBMP16 (Image)
  END IF
END SUB

SUB SaveBMP16 (Image AS INTEGER)

SELECT CASE Image
CASE 0
MustWidth%=128
MustHeight%=128
TextureSize=32768
CASE 1
MustWidth%=256
MustHeight%=TextureHeight
TextureSize=MustWidth%*MustHeight%*2
CASE ELSE
GOTO AbortLoadBMP16
END SELECT

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Status1.SimpleText="Writing Header..."
Form1.Show
BMSignature$="BM":File.WriteStr(BMSignature$,2)
BMFileSize&=&H36+TextureSize:File.Write(BMFileSize&)
BMreserved&=0:File.Write(BMreserved&)
BMDataOffset&=&H36:File.Write(BMDataOffset&)
BMSize&=&H28:File.Write(BMSize&)
BMWidth&=MustWidth%:File.Write(BMWidth&)
BMHeight&=MustHeight%:File.Write(BMHeight&)
BMPlanes%=1:File.Write(BMPlanes%)
BMBitCount%=16:File.Write(BMBitCount%)
BMCompression&=0:File.Write(BMCompression&)
BMImageSize&=0:File.Write(BMImageSize&)
BMXpixelsPerM&=1:File.Write(BMXpixelsPerM&)
BMYpixelsPerM&=1:File.Write(BMYpixelsPerM&)
BMColorsUsed&=&H1000000:File.Write(BMColorsUsed&)
BMColorsImportant&=0:File.Write(BMColorsImportant&)
Status1.SimpleText="Writing scanlines..."
Form1.Show

SELECT CASE Image

CASE 0
FOR X = 0 TO 127
File.SaveArray(Sprite(128 -X -1, 0),128)
NEXT X

CASE 1
FOR X = 0 TO TextureHeight -1
File.SaveArray(Texture(TextureHeight -X -1, 0),256)
NEXT X

END SELECT

Status1.SimpleText="Done"
Form1.Show
File.Close

END SUB


SUB ImportBMP16 (Image AS INTEGER)

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "BMP Files (*.bmp)|*.bmp"
  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadBMP16 (Image)
  END IF
END SUB

SUB LoadBMP16 (Image AS INTEGER)

SELECT CASE Image
CASE 0
MustWidth%=128
MustHeight%=128
TextureSize=32768
CASE 1
MustWidth%=256
MustHeight%=TextureHeight
TextureSize=MustWidth%*MustHeight%*2
CASE ELSE
GOTO AbortLoadBMP16
END SELECT

DIM File AS QFileStream
File.Open(FileName$, fmRead)
Status1.SimpleText="Reading Header..."
Form1.Show
BMSignature$=File.ReadStr(2)
IF LEFT$(BMSignature$,2)<>"BM" THEN SHOWMESSAGE "Not a BMP image!":GOTO AbortLoadBMP16
File.Read(BMFileSize&)
IF BMFileSize&<>&H36+TextureSize THEN SHOWMESSAGE "BMP has wrong filesize.":GOTO AbortLoadBMP16
File.Read(BMreserved&)
'IF BMreserved&<>0 THEN SHOWMESSAGE "Reserved byte isn't 0.":GOTO AbortLoadBMP16
File.Read(BMDataOffset&)
IF BMDataOffset&<>&H36 THEN SHOWMESSAGE "Wrong data offset.":GOTO AbortLoadBMP16
File.Read(BMSize&)
IF BMSize&<>&H28 THEN SHOWMESSAGE "BMP has wrong header size.":GOTO AbortLoadBMP16
File.Read(BMWidth&)
IF BMWidth&<>MustWidth% THEN SHOWMESSAGE "BMP isn't "+STR$(MustWidth%)+" pixels wide.":GOTO AbortLoadBMP16
File.Read(BMHeight&)
IF BMHeight&<>MustHeight% THEN SHOWMESSAGE "BMP isn't "+STR$(MustHeight%)+" pixels tall.":GOTO AbortLoadBMP16
File.Read(BMPlanes%)
IF BMPlanes%<>1 THEN SHOWMESSAGE "BMP has more than 1 plane.":GOTO AbortLoadBMP16
File.Read(BMBitCount%)
IF BMBitCount%<>16 THEN SHOWMESSAGE "BMP doesn't have a 16-bit color depth.":GOTO AbortLoadBMP16
File.Read(BMCompression&)
IF BMCompression&<>0 THEN SHOWMESSAGE "BMP isn't uncompressed.":GOTO AbortLoadBMP16
File.Read(BMImageSize&)
' IF BMImageSize&<>0  THEN SHOWMESSAGE "BMP size not set to 0.":GOTO AbortLoadBMP16
File.Read(BMXpixelsPerM&)
'IF BMXpixelsPerM&<>1 THEN SHOWMESSAGE "BMP horizontal resolution isn't 1 pixel/m.":GOTO AbortLoadBMP16
File.Read(BMYpixelsPerM&)
'IF BMYpixelsPerM&<>1 THEN SHOWMESSAGE "BMP vertical resolution isn't 1 pixel/m.":GOTO AbortLoadBMP16
File.Read(BMColorsUsed&)
'IF BMColorsUsed&<>&H1000000 THEN SHOWMESSAGE "BMP doesn't use 16 million colors.":GOTO AbortLoadBMP16
File.Read(BMColorsImportant&)
'IF BMColorsImportant&<>0 THEN SHOWMESSAGE "BMP has important colors set.":GOTO AbortLoadBMP16

Status1.SimpleText="Reading scanlines..."
Form1.Show

SELECT CASE Image
CASE 0
FOR X = 0 TO 127
File.LoadArray(Sprite(128 -X -1, 0),128)
NEXT X
DrawSprite555
Status1.SimpleText="Done"
Form1.Show
SpriteCanvas.Repaint

CASE 1
FOR X = 0 TO TextureHeight -1
File.LoadArray(Texture(TextureHeight -X -1, 0),256)
NEXT X
InitScreen
StoreBitmap(0)
'    BitMap.PixelFormat = pf24Bit
    BitMap.Height = 256
	myTexture = GL.CreateTextureFromBitmap(BitMap)   	'load texture, put id in myTexture 
'    BitMap.PixelFormat = pf32Bit
 meshbuilder

END SELECT

Status1.SimpleText="Done"
AbortLoadBMP16:
Form1.Show
File.Close

END SUB


SUB ExportBMP32 (Image AS INTEGER)

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "BMP Files (*.bmp)|*.bmp"
  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".bmp") = 0 THEN FileName$=FileName$+".bmp"
      Status1.SimpleText="Exporting "+FileName$
    SaveBMP32 (Image)
  END IF
END SUB

SUB SaveBMP32 (Image AS INTEGER)

SELECT CASE Image
CASE 0
SpriteBitMap.SaveToFile(FileName$)

CASE 1
BitMap.Height=TextureHeight
BitMap.SaveToFile(FileName$)
BitMap.Height=256

END SELECT

Status1.SimpleText="Done"
Form1.Show

END SUB


SUB ImportBMP32 (Image AS INTEGER)

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "BMP Files (*.bmp)|*.bmp"
  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadBMP32 (Image)
  END IF
END SUB

SUB LoadBMP32 (Image AS INTEGER)

SELECT CASE Image
CASE 0
MustWidth%=128
MustHeight%=128
CASE 1
MustWidth%=256
MustHeight%=TextureHeight
CASE ELSE
GOTO AbortLoadBMP32
END SELECT

DIM File AS QFileStream
File.Open(FileName$, fmRead)
Status1.SimpleText="Reading Header..."
Form1.Show
BMSignature$=File.ReadStr(2)
File.Read(BMFileSize&)
File.Read(BMreserved&)
File.Read(BMDataOffset&)
File.Read(BMSize&)
File.Read(BMWidth&)
File.Read(BMHeight&)
File.Read(BMPlanes%)
File.Read(BMBitCount%)
File.Read(BMCompression&)
File.Read(BMImageSize&)
File.Read(BMXpixelsPerM&)
File.Read(BMYpixelsPerM&)
File.Read(BMColorsUsed&)
File.Read(BMColorsImportant&)
File.close

IF LEFT$(BMSignature$,2)<>"BM" THEN SHOWMESSAGE "Not a BMP image!":GOTO AbortLoadBMP32
'IF BMFileSize&<>&H36+TextureSize THEN SHOWMESSAGE "BMP has wrong filesize.":GOTO AbortLoadBMP32
'IF BMreserved&<>0 THEN SHOWMESSAGE "Reserved byte isn't 0.":GOTO AbortLoadBMP32
IF BMDataOffset&<>&H36 THEN SHOWMESSAGE "Wrong data offset.":GOTO AbortLoadBMP32
IF BMSize&<>&H28 THEN SHOWMESSAGE "BMP has wrong header size.":GOTO AbortLoadBMP32
IF BMWidth&<>MustWidth% THEN SHOWMESSAGE "BMP isn't "+STR$(MustWidth%)+" pixels wide.":GOTO AbortLoadBMP32
IF BMHeight&<>MustHeight% THEN SHOWMESSAGE "BMP isn't "+STR$(MustHeight%)+" pixels tall.":GOTO AbortLoadBMP32
IF BMPlanes%<>1 THEN SHOWMESSAGE "BMP has more than 1 plane.":GOTO AbortLoadBMP32
IF BMBitCount%<>32 AND BMBitCount%<>24 THEN SHOWMESSAGE "BMP doesn't have a 24- or 32-bit color depth.":GOTO AbortLoadBMP32
IF BMCompression&<>0 THEN SHOWMESSAGE "BMP isn't uncompressed.":GOTO AbortLoadBMP32
' IF BMImageSize&<>0  THEN SHOWMESSAGE "BMP size not set to 0.":GOTO AbortLoadBMP32
'IF BMXpixelsPerM&<>1 THEN SHOWMESSAGE "BMP horizontal resolution isn't 1 pixel/m.":GOTO AbortLoadBMP32
'IF BMYpixelsPerM&<>1 THEN SHOWMESSAGE "BMP vertical resolution isn't 1 pixel/m.":GOTO AbortLoadBMP32
'IF BMColorsUsed&<>&H1000000 THEN SHOWMESSAGE "BMP doesn't use 16 million colors.":GOTO AbortLoadBMP32
'IF BMColorsImportant&<>0 THEN SHOWMESSAGE "BMP has important colors set.":GOTO AbortLoadBMP32

Status1.SimpleText="Reading scanlines..."
Form1.Show

SELECT CASE Image
CASE 0
SpriteBitMap.LoadFromFile(FileName$)
SpriteRGBto555
DrawSprite555
Status1.SimpleText="Done"
Form1.Show
SpriteCanvas.Repaint

CASE 1
BitMap.LoadFromFile(FileName$)
    BitMap.PixelFormat = pf32Bit
RGBto555
InitScreen
StoreBitmap(0)
'    BitMap.PixelFormat = pf24Bit
    BitMap.Height = 256
	myTexture = GL.CreateTextureFromBitmap(BitMap)   	'load texture, put id in myTexture 
'    BitMap.PixelFormat = pf32Bit
 meshbuilder

END SELECT

Status1.SimpleText="Done"
AbortLoadBMP32:
Form1.Show

END SUB



SUB ExportJPG (Image AS INTEGER)

  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "JPEG Files (*.jpg)|*.jpg"
  IF CurrentType=1 THEN SaveDialog.FileName=ModelName
  IF CurrentType=2 THEN SaveDialog.FileName=CurrentName$
  IF SaveDialog.Execute THEN
    FileName$=SaveDialog.FileName
  IF INSTR(FileName$,".jpg") = 0 THEN FileName$=FileName$+".jpg"
    Status1.SimpleText="Exporting "+FileName$
    SaveJPG (Image)
  END IF
END SUB

SUB SaveJPG (Image AS INTEGER)

SELECT CASE Image
CASE 0
XBitMap.Height=128
XBitMapWidth=128
XBitMap.BMP=SpriteBitMap.BMP

CASE 1
XBitMap.Height=BitMap.Height
XBitMapWidth=256
XBitMap.BMP=BitMap.BMP
XBitMap.Height=TextureHeight

END SELECT

XBitMap.SaveAsJpg(FileName$,100)

Status1.SimpleText="Done"
Form1.Show

END SUB


SUB ImportJPG (Image AS INTEGER)

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "Picture files|*.BMP;*.ICO;*.JPG;*.GIF;*.DIB;*.RLE;*.TGA;*.PCX"
  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Importing "+FileName$
    LoadJPG (Image)
  END IF
END SUB


SUB LoadJPG (Image AS INTEGER)

SELECT CASE Image
CASE 0
MustWidth%=128
MustHeight%=128
CASE 1
MustWidth%=256
MustHeight%=TextureHeight
CASE ELSE
GOTO AbortLoadJPG
END SELECT

Status1.SimpleText="Reading image..."
Form1.Show
XBitMap.LoadOtherImage(FileName$,True,"English")
IF XbitMap.Width<>MustWidth% THEN SHOWMESSAGE "image isn't "+STR$(MustWidth%)+" pixels wide.":GOTO AbortLoadJPG
IF XBitMap.Height<>MustHeight% THEN SHOWMESSAGE "image isn't "+STR$(MustHeight%)+" pixels tall.":GOTO AbortLoadJPG
Status1.SimpleText="Processing image..."
Form1.Show

SELECT CASE Image
CASE 0
SpriteCanvas.Draw(0,0,XBitMap.BMP)
SpriteBitMap.BMP=XBitMap.BMP
SpriteRGBto555
DrawSprite555
Status1.SimpleText="Done"
Form1.Show
SpriteCanvas.Repaint

CASE 1
Canvas.Draw(0,0,XBitMap.BMP)
XBitMap.PixelFormat = pf32bit
BitMap.Height=TextureHeight
BitMap.BMP=XBitMap.BMP
RGBto555
InitScreen
StoreBitmap(0)
'    BitMap.PixelFormat = pf24Bit
    BitMap.Height = 256
	myTexture = GL.CreateTextureFromBitmap(BitMap)   	'load texture, put id in myTexture 
 	glBindTexture GL_TEXTURE_2D, myTexture                 '' Select new Texture if needed 
'    BitMap.PixelFormat = pf32Bit
 meshbuilder

END SELECT

Status1.SimpleText="Done"
AbortLoadJPG:
Form1.Show

END SUB


SUB ExportTGA_0
ExportTGA(0)
END SUB

SUB ImportTGA_0
ImportTGA(0)
END SUB

SUB ExportBMP16_0
ExportBMP16(0)
END SUB

SUB ImportBMP16_0
ImportBMP16(0)
END SUB

SUB ExportBMP32_0
ExportBMP32(0)
END SUB

SUB ImportBMP32_0
ImportBMP32(0)
END SUB

SUB ExportJPG_0
ExportJPG(0)
END SUB

SUB ImportJPG_0
ImportJPG(0)
END SUB


SUB ExportTGA_1
ExportTGA(1)
END SUB

SUB ImportTGA_1
ImportTGA(1)
END SUB

SUB ExportBMP16_1
ExportBMP16(1)
END SUB

SUB ImportBMP16_1
ImportBMP16(1)
END SUB

SUB ExportBMP32_1
ExportBMP32(1)
END SUB

SUB ImportBMP32_1
ImportBMP32(1)
END SUB

SUB ExportJPG_1
ExportJPG(1)
END SUB

SUB ImportJPG_1
ImportJPG(1)
END SUB



SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)
    Canvas.Hint=""
    Canvas.Hint=STR$(X)+","+STR$(Y)
END SUB      

SUB CanvasPaint
    W = Canvas.ClientWidth
    H = Canvas.ClientHeight
    Canvas.FillRect(0, 0, W, H, 0)

    Canvas.Draw(0,0, Bitmap.BMP)
END SUB

SUB FileOpen

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "CAR Files (*.car)|*.car|3DF Files (*.3df)|*.3df|C1 Object Files (*.c1o)|*.c1o|C2/IA Object Files (*.c2o)|*.c2o"

  IF OpenDialog.Execute THEN
    FileType=OpenDialog.FilterIndex
    FileName$=OpenDialog.FileName
    Status1.SimpleText="Viewing "+FileName$
    LoadCarFile
   END IF
END SUB

     


SUB ExitClick
  Form1.Close
END SUB  


SUB LoadCarFile

CurrentType=FileType
CurrentName$=LCASE$( LEFT$(FileName$, RINSTR( LCASE$(FileName$), ".3df") -1 ) )

ShowMenu.Enabled=False
ShowObj.Enabled=False
ViewCyl.Enabled=False
ViewCirc.Enabled=False
ViewSphere.Enabled=False
TextureMenu.Enabled=False
AnimMenu.Enabled=False
SfxMenu.Enabled=False
ShowSubList.Enabled=False
ShowAnimList.Enabled=False
ShowSfxList.Enabled=False
ShowTable.Enabled=False
ShowSprite.Enabled=False
SaveFile.Enabled = False  
ExportMesh.Enabled = False  
    

TextPopUp.Close
SpritePopUp.Close
      

DIM File AS QFileStream
File.Open(FileName$, fmOpenRead)
Status1.SimpleText="Reading Header Data..."
Form1.Show
IF FileType=1 THEN
File.Read(ModelName)
Status1.SimpleText="Model Name: "+ModelName
Form1.Show

File.Read(AniCount)
Status1.SimpleText="Animations: "+STR$(AniCount)
Form1.Show

File.Read(SfxCount)
Status1.SimpleText="Sound FX: "+STR$(SfxCount)
Form1.Show

END IF

IF FileType>2 THEN File.ReadUDT(ObjInfo):IF ObjInfo.Flags AND &H80000000 THEN AniCount=1 ELSE AniCount=0

File.Read(VCount)
Status1.SimpleText="Vertices: "+STR$(VCount)
Form1.Show

File.Read(FCount)
Status1.SimpleText="Faces: "+STR$(FCount)
Form1.Show

OCount=0
IF FileType>1 THEN
File.Read(OCount)
Status1.SimpleText="Objects: "+STR$(OCount)
Form1.Show
END IF

File.Read(TextureSize)
TextureHeight=TextureSize/512
Status1.SimpleText="Texture size: "+STR$(TextureSize)+" Bytes (256x"+STR$(TextureHeight)+" pixels)"
Form1.Show

DIM TMPFlags AS WORD
Index1 = 0: Index2 = 0: Index3 = 0
Index4 = 0: Index5 = 0: Index6 = 0
Index7 = 0
DIM TMPgroup AS INTEGER
MEMSET(VARPTR(SubObjList(0,0)),0,64*1024*SIZEOF(INTEGER))
MEMSET(VARPTR(SubObjIndex(0)),0,64*SIZEOF(INTEGER))
FOR A1 = 1 TO FCount
Status1.SimpleText="Reading Face: "+STR$(A1)
Form1.Show
File.ReadUDT(FaceList(A1 - 1))
TMPgroup=FaceList(A1-1).group
' IF FileType = 1 THEN IF TMPgroup>OCount-1 THEN OCount=TMPgroup+1:ObjList(TMPgroup)=DummyObj
SubObjList(TMPGroup,SubObjIndex(TMPGroup)) = A1 - 1 : INC(SubObjIndex(TMPgroup))
TMPFlags=FaceList(A1-1).Flags
IF (TMPFlags AND sfMortal) THEN  List7(Index7) = A1 - 1: Index7++
IF (TMPFlags AND sfTransparent) THEN
 IF (TMPFlags AND sfDoubleSide) THEN
  List4(Index4) = A1 - 1: Index4++
 ELSE
  List1(Index1) = A1 - 1: Index1++
 END IF
ELSE
 IF (TMPFlags AND sfOpacity) THEN
  IF (TMPFlags AND sfDoubleSide) THEN
   List5(Index5) = A1 - 1: Index5++
  ELSE
   List2(Index2) = A1 - 1: Index2++
  END IF
 ELSE
  IF (TMPFlags AND sfDoubleSide) THEN
   List6(Index6) = A1 - 1: Index6++
     ELSE
   List3(Index3) = A1 - 1: Index3++
  END IF
 END IF
END IF

NEXT A1

DIM TMPowner AS SHORT

DIM TMPobj AS 3df_Obj
	TMPobj.objName = "Object0"+CHR$(0)
	TMPobj.ox = 0
	TMPobj.oy = 0
	TMPobj.oz = 0
	TMPobj.owner = -1
	TMPobj.hide = 0
 
IF FileType = 1 THEN ObjList(0)=TMPobj:OCount=1

FOR A1 = 1 TO VCount
Status1.SimpleText="Reading Vertex: "+STR$(A1)
Form1.Show
File.ReadUDT(PointList(A1 - 1))
IF FileType = 1 THEN
TMPowner=PointList(A1-1).owner
 IF TMPowner>OCount-1 THEN
  OCount=TMPowner+1
'  TMPobj.owner=0
  TMPobj.objName="Object"+STR$(TMPowner)+CHR$(0)
  ObjList(TMPowner)=TMPobj
 END IF
END IF

NEXT A1

IF FileType>1 THEN
FOR A1 = 1 TO OCount
Status1.SimpleText="Reading Object: "+STR$(A1)
Form1.Show
File.ReadUDT(ObjList(A1 - 1))
NEXT A1
ShowSubList.Enabled=True
END IF

'suboList=glGenLists(OCount)
ObjIndex=0
ObjScrollSelect.Max=OCount-1

TriIndex=0
TriScrollSelect.Max=FCount-1

Status1.SimpleText="Loading texture..."
Form1.Show
'Form1.ClientWidth = 256
'Form1.ClientHeight = 256+24
Canvas.Width = 256
 Canvas.Height = TextureHeight
 Canvas.Height = 256
Canvas.ClientWidth = 256
 Canvas.ClientHeight = TextureHeight
 Canvas.ClientHeight = 256
BitMap.Width = 256
 BitMap.Height = TextureHeight
 BitMap.Height = 256
'Form1.Center
File.LoadArray(Texture(0, 0),256*TextureHeight)
Status1.SimpleText="Texture loaded, 256x"+STR$(TextureHeight)+" pixels."
Form1.Show
InitScreen
StoreBitmap(0)

'Form1.Caption="Filetype: "+STR$(FileType)
'Form1.Show

IF FileType=4 THEN
Status1.SimpleText="Loading sprite..."
Form1.Show
'Form1.ClientWidth = 256
'Form1.ClientHeight = 256+24
 SpriteCanvas.Width = 128
 SpriteCanvas.Height = 128
 SpriteCanvas.ClientWidth = 128
 SpriteCanvas.ClientHeight = 128
 SpriteBitMap.Width = 128
 SpriteBitMap.Height = 128
'Form1.Center
 File.LoadArray(Sprite(0, 0),128*128)
    DrawSprite555
Status1.SimpleText="Sprite loaded."
ShowSprite.Enabled=True
Form1.Show
' InitScreen
' StoreBitmap(0)

END IF

IF FileType<>2 THEN
FOR A1 = 1 TO AniCount
Status1.SimpleText="Reading Animation: "+STR$(A1)
Form1.Show
IF FileType<2 THEN
File.Read(TMPaniName)
AnimList(A1-1).aniName=TMPaniName
Status1.SimpleText="Animation "+STR$(A1)+" Name: "+TMPaniName
Form1.Show
END IF
IF FileType>2 THEN
File.Read(TMPvCount1)
File.Read(TMPvCount2)
END IF
File.Read(TMPaniKPS)
AnimList(A1-1).aniKPS=TMPaniKPS
Status1.SimpleText="Animation "+STR$(A1)+" KPS: "+STR$(TMPaniKPS)
Form1.Show
File.Read(TMPFramesCount)
AnimList(A1-1).FramesCount=TMPFramesCount
IF FileType>2 THEN TMPFramesCount++
Status1.SimpleText="Animation "+STR$(A1)+" Frames: "+STR$(TMPFramesCount)
Form1.Show
TMPaniTime=TMPFramesCount*1000/TMPaniKPS
AnimList(A1-1).aniTime=TMPaniTime
 FOR Frame=1 to TMPFramesCount
  FOR Vertex=1 TO VCount
   FOR Coord=1 TO 3
    File.Read(TMPaniCoord)
    AnimData(A1-1,Frame-1,Vertex-1,Coord-1)=TMPaniCoord
   NEXT Coord
'  Status1.SimpleText="Data "+STR$(A1)+","+STR$(Frame)+","+STR$(Vertex)+"="+STR$(AnimData(A1-1,Frame-1,Vertex-1,0))+","+STR$(AnimData(A1-1,Frame-1,Vertex-1,1))+","+STR$(AnimData(A1-1,Frame-1,Vertex-1,2))
  NEXT Vertex
 NEXT Frame
NEXT A1

IF AniCount>0 THEN

 ShowAnimList.Enabled=True
    AnimScrollSelect.Max=AniCount-1
    AnimScrollSelect.Position=0
    AnimLabelName.Caption = AnimList(0).aniName
    AnimMenu.Enabled=True

END IF

END IF

IF FileType=1 THEN

FOR A1 = 1 TO SfxCount
Status1.SimpleText="Reading Sound: "+STR$(A1)
Form1.Show
File.Read(TMPsfxName)
SoundList(A1-1).sfxName=TMPsfxName
Status1.SimpleText="Sound "+STR$(A1)+" Name: "+TMPsfxName
Form1.Show
File.Read(TMPlength)
SoundList(A1-1).length=TMPlength
Status1.SimpleText="Sound "+STR$(A1)+" length: "+STR$(TMPlength)+" bytes"
Form1.Show
TMPlpData=File.ReadBinStr(TMPlength)
SoundList(A1-1).lpData = TMPlpData
'play (TMPlength, TMPlpData)
NEXT A1

IF SfxCount>0 THEN
    File.LoadArray(AniFX(0),64)
    Status1.SimpleText="Sound table loaded."
    Form1.Show
    
    SfxScrollSelect.Max=SfxCount-1
    SfxScrollSelect.Position=0
    AnimSfxScrollSelect.Max=SfxCount-1
    AnimSfxScrollSelect.Position=AniFX(0)
    SfxLabelName.Caption = SoundList(0).sfxName
    AnimSfxLabelName.Caption = SoundList(AniFX(0)).sfxName
    SfxMenu.Enabled=True
    SfxSelect.Enabled=True
    ShowSfxList.Enabled=True
    ShowTable.Enabled=True
    
END IF
END IF

    Status1.SimpleText=FileName$+" loaded OK."
    SaveFile.Enabled = True  
    ExportMesh.Enabled = True  

IF FileType>2 THEN
ShowObj.Enabled=True
ViewCyl.Enabled=True
ViewCirc.Enabled=True
ViewSphere.Enabled=True
ELSE
ViewCyl.Checked=False
ViewCirc.Checked=False
ViewSphere.Checked=False
END IF
ShowMenu.Enabled=True
TextureMenu.Enabled=True
File.Close
SfxIndex=0
InitMesh
MEMSET(TriListAddr,0,1024*SIZEOF(BYTE))
InitList
ViewMesh
END SUB

SUB StoreBitmap (Z AS INTEGER)

FOR X = 0 TO TextureHeight-1
FOR Y = 0 TO 255

R = Texture(X, Y)

D=R

ROJO=INT((D AND &H7C00)/&H400)
VERDE=(INT(D AND &H03E0)/&H20)
AZUL=INT(D AND &H001F)

D=(AZUL*&H80000+VERDE*&H800+ROJO*8)' : IF D<>0 THEN D=D OR &HFF000000

H = Y: V = X + 256*Z
H1 = Y + 1: V1 = X + 1 + 256*Z
TextureList.Rectangle(H, V, H1, V1, D)

NEXT Y: NEXT X


END SUB

SUB InitScreen

Canvas.Visible = False

Form1.Color = 0

DrawPicture555
Canvas.Visible = True
Canvas.Repaint
Canvas.ShowHint=True

END SUB


SUB DrawPicture555
BitMap.Height=256
TexBufferAddr=VARPTR(TexBuffer(0,0))
MEMSET(TexBufferAddr,0,256*256*SIZEOF(INTEGER))

FOR X = 0 TO TextureHeight-1
FOR Y = 0 TO 255

R = Texture(X, Y)

D=R

ROJO=INT((D AND &H7C00)/&H400)
VERDE=INT((D AND &H03E0)/&H20)
AZUL=INT(D AND &H001F)

''D=(AZUL*&H80000+VERDE*&H800+ROJO*8)' : IF D<>0 THEN D=(D AND &HFFFFFF) OR &HFF000000
D=(ROJO*&H80000+VERDE*&H800+AZUL*8) : IF D<>0 THEN D=D OR &HFF000000 ELSE D=D AND &HFFFFFF
H = Y: V = X
'H1 = Y + 1: V1 = X + 1
'BitMap.Rectangle(H, V, H1, V1, D)
''BitMap.Pixel(H, V)= D
''IF D<>0 THEN D=(D AND &HFFFFFF) OR &HFF000000
TexBuffer(255-V,H) = D
NEXT Y: NEXT X
MEMCPY(BitMap.Pointer,TexBufferAddr,256*256*4)
' BitMap.TransparentColor=0
' BitMap.TransparentMode=tmAlpha
END SUB

SUB RGBto555

FOR X = 0 TO TextureHeight-1
FOR Y = 0 TO 255

R = BitMap.Pixel(Y, X)

D=R

ROJO=INT((D AND &HF8)/8)
VERDE=INT((D AND &HF800)/&H800)
AZUL=(INT(D AND &HF80000)/&H80000)

D=(AZUL+VERDE*&H20+ROJO*&H400)

Texture(X, Y) = D

NEXT Y: NEXT X

END SUB



sub play (length AS INTEGER, wavdata AS STRING)
'	doevents

	'## stop sound and delete it
	playsound(0, 0, 0)
	soundstream.close

	soundstream.writestr("RIFF", 4) '## indicates wave file header chunk
	soundstream.writenum(length+36, 4) '## total length of package to follow, 4 bytes

	soundstream.writestr("WAVE", 4)

	soundstream.writestr("fmt ", 4) '## begin format chunk
	soundstream.writenum(16, 4)     '## length of format chunk
	soundstream.writenum(1,  2)     '## WAVE_FORMAT_PCM
	soundstream.writenum(1,  2)     '## channels 1-mono 2-stereo
	soundstream.writenum(22050,  4) '## sample rate in Hz
	soundstream.writenum(44100,  4) '## bytes per second (samplerate * channels * bytespersample)
	soundstream.writenum(2,  2)     '## bytes per sample
	soundstream.writenum(16, 2)     '## bits per sample

	soundstream.writestr("data", 4) '## begin data chunk
	soundstream.writenum(length, 4) '## length of data to follow
	soundstream.writestr(wavdata, length) '## wave data
	'## play from memory
	playsound(soundstream.pointer, 0, 4) '## SND_ASYNC=1, SND_MEMORY=4
end sub

sub saveWav (fn AS STRING, length AS INTEGER, wavdata AS STRING)
'	doevents

'      WavFile.close
      WavFile.Open(fn, fmCreate)

	WavFile.writestr("RIFF", 4) '## indicates wave file header chunk
	WavFile.writenum(length+36, 4) '## total length of package to follow, 4 bytes

	WavFile.writestr("WAVE", 4)

	WavFile.writestr("fmt ", 4) '## begin format chunk
	WavFile.writenum(16, 4)     '## length of format chunk
	WavFile.writenum(1,  2)     '## WAVE_FORMAT_PCM
	WavFile.writenum(1,  2)     '## channels 1-mono 2-stereo
	WavFile.writenum(22050,  4) '## sample rate in Hz
	WavFile.writenum(44100,  4) '## bytes per second (samplerate * channels * bytespersample)
	WavFile.writenum(2,  2)     '## bytes per sample
	WavFile.writenum(16, 2)     '## bits per sample

	WavFile.writestr("data", 4) '## begin data chunk
	WavFile.writenum(length, 4) '## length of data to follow
	WavFile.writestr(wavdata, length) '## wave data
      WavFile.close
end sub

sub loadWav (fn AS STRING)
'	doevents

'      WavFile.close
      WavFile.Open(fn, fmRead)

	wavChunkID$=WavFile.readstr(4) '## indicates wave file header chunk
      IF LEFT$(wavChunkID$,4)<>"RIFF" THEN SHOWMESSAGE "Not a RIFF file.":GOTO AbortLoadWav
      wavChunkSize&=WavFile.readnum(4) '## total length of package to follow, 4 bytes
      IF wavChunkSize&>WavFile.Size-8 THEN SHOWMESSAGE "Filesize mismatch.":GOTO AbortLoadWav
	wavFormat$=WavFile.readstr(4) '## indicates wave format
      IF LEFT$(wavFormat$,4)<>"WAVE" THEN SHOWMESSAGE "Not a WAVE format file.":GOTO AbortLoadWav
	wavSubchunk1ID$=WavFile.readstr(4) '## begin format chunk
      IF LEFT$(wavSubchunk1ID$,4)<>"fmt " THEN SHOWMESSAGE "Format subchunk not found.":GOTO AbortLoadWav
      wavSubchunk1Size&=WavFile.readnum(4) '## length of format chunk
'      IF wavSubchunk1Size&<>16 THEN SHOWMESSAGE "Incorrect subchunk size.":GOTO AbortLoadWav
      wavAudioFormat%=WavFile.readnum(2) '## WAVE_FORMAT_PCM
      IF wavAudioFormat%<>1 THEN SHOWMESSAGE "Not a PCM format wavefile.":GOTO AbortLoadWav
      wavNumChannels%=WavFile.readnum(2) '## channels 1-mono 2-stereo
      IF wavNumChannels%<>1 THEN SHOWMESSAGE "Not a single-channel wavefile.":GOTO AbortLoadWav
      wavSampleRate&=WavFile.readnum(4) '## sample rate in Hz
      IF wavSampleRate&<>22050 THEN SHOWMESSAGE "Not a 22050Hz sample rate.":GOTO AbortLoadWav
      wavByteRate&=WavFile.readnum(4) '## bytes per second (samplerate * channels * bytespersample)
      IF wavByteRate&<>44100 THEN SHOWMESSAGE "Not a 44100 bytes per second rate.":GOTO AbortLoadWav
      wavBlockAlign%=WavFile.readnum(2) '## bytes per sample
      IF wavBlockAlign%<>2 THEN SHOWMESSAGE "Not a 2 bytes per sample size.":GOTO AbortLoadWav
      wavBitsPerSample%=WavFile.readnum(2) '## bits per sample
      IF wavBitsPerSample%<>16 THEN SHOWMESSAGE "Not a 16 bits per sample size.":GOTO AbortLoadWav
      IF wavSubchunk1Size&<>16 THEN
          wavExtraFormatBytes%=WavFile.readnum(2) '## extra format bytes
          IF wavExtraFormatBytes%<>0 THEN wavExtra$=WavFile.readstr(wavExtraFormatBytes%)
      END IF
	wavSubchunk2ID$=WavFile.readstr(4) '## begin data chunk or fact chunk
      IF LEFT$(wavSubchunk2ID$,4)<>"data" THEN
            factSubchunkID$=wavSubchunk2ID$
            IF LEFT$(factSubchunkID$,4)<>"fact" THEN SHOWMESSAGE "Not a Data or Fact subchunk.":GOTO AbortLoadWav
            factSubchunkSize&=WavFile.readnum(4) '## total length of package to follow, at least 4 bytes
'            IF factSubchunkSize&<>4 THEN SHOWMESSAGE "Incorrect fact subchunk size.":GOTO AbortLoadWav
'            wavSampleLength&=WavFile.readnum(4) '## number of samples per channel
            wavFactSubChunk$=WavFile.readBinstr(factSubchunkSize&) '## ignore this block (shouldn't even be there in the first place)
            wavSubchunk2ID$=WavFile.readstr(4) '## begin data chunk
            IF LEFT$(wavSubchunk2ID$,4)<>"data" THEN SHOWMESSAGE "Data subchunk not found.":GOTO AbortLoadWav
      END IF
      wavSubchunk2Size&=WavFile.readnum(4) '## length of data to follow
'      IF wavSubchunk2Size&<>WavFile.Size-44 AND wavSubchunk2Size&<>WavFile.Size-56 THEN SHOWMESSAGE "Incorrect data size.":GOTO AbortLoadWav
      IF wavSubchunk2Size&>WavFile.Size-WavFile.Position THEN SHOWMESSAGE "Incorrect data size.":GOTO AbortLoadWav
	wavData$=WavFile.readBinstr(wavSubchunk2Size&) '## wave data
    SoundList(SfxIndex).sfxName=TMPsfxName
    SoundList(SfxIndex).length=wavSubchunk2Size&
    SoundList(SfxIndex).lpData=wavData$
    Status1.SimpleText="Replaced sound "+STR$(SfxIndex)+": "+TMPsfxName
AbortLoadWav:
    WavFile.close
end sub

SUB FileSave
  
  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  IF CurrentType=1 THEN SaveDialog.Filter = "CAR Files (*.car)|*.car"
  IF CurrentType=2 THEN SaveDialog.Filter = "3DF Files (*.3df)|*.3df"
  IF CurrentType=3 THEN SaveDialog.Filter = "C1 Object Files (*.c1o)|*.c1o"
  IF CurrentType=4 THEN SaveDialog.Filter = "C2/IA Object Files (*.c2o)|*.c2o"

  IF SaveDialog.Execute THEN
    FileType=SaveDialog.FilterIndex
    FileName$=SaveDialog.FileName
  IF CurrentType=1 AND INSTR(LCASE$(FileName$),".car") = 0 THEN FileName$=FileName$+".car"
  IF CurrentType=2 AND INSTR(LCASE$(FileName$),".3df") = 0 THEN FileName$=FileName$+".3df"
  IF CurrentType=3 AND INSTR(LCASE$(FileName$),".c1o") = 0 THEN FileName$=FileName$+".c1o"
  IF CurrentType=4 AND INSTR(LCASE$(FileName$),".c2o") = 0 THEN FileName$=FileName$+".c2o"
    Status1.SimpleText="Saving "+FileName$
    SaveCarFile
'    ShowMenu.Enabled=True
   END IF
END SUB

SUB SaveCarFile

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Status1.SimpleText="Writing Header Data..."
Form1.Show
IF CurrentType=1 THEN
File.WriteBinStr(ModelName,32)
Status1.SimpleText="Model Name: "+ModelName
Form1.Show

File.Write(AniCount)
Status1.SimpleText="Animations: "+STR$(AniCount)
Form1.Show

File.Write(SfxCount)
Status1.SimpleText="Sound FX: "+STR$(SfxCount)
Form1.Show
END IF

IF CurrentType>2 THEN File.WriteUDT(ObjInfo)

File.Write(VCount)
Status1.SimpleText="Vertices: "+STR$(VCount)
Form1.Show

File.Write(FCount)
Status1.SimpleText="Faces: "+STR$(FCount)
Form1.Show

IF CurrentType>1 THEN
File.Write(OCount)
Status1.SimpleText="Objects: "+STR$(OCount)
Form1.Show
END IF

File.Write(TextureSize)
Status1.SimpleText="Texture size: "+STR$(TextureSize)+" Bytes (256x"+STR$(TextureHeight)+" pixels)"
Form1.Show

FOR A1 = 1 TO FCount
Status1.SimpleText="Writing Face: "+STR$(A1)
Form1.Show
File.WriteUDT(FaceList(A1 - 1))
NEXT A1

FOR A1 = 1 TO VCount
Status1.SimpleText="Writing Vertex: "+STR$(A1)
Form1.Show
File.WriteUDT(PointList(A1 - 1))
NEXT A1

IF CurrentType>1 THEN
FOR A1 = 1 TO OCount
Status1.SimpleText="Writing Object: "+STR$(A1)
Form1.Show
File.WriteUDT(ObjList(A1 - 1))
NEXT A1
END IF

Status1.SimpleText="Writing texture..."
Form1.Show
'Form1.Center
File.SaveArray(Texture(0, 0),256*TextureHeight)
Status1.SimpleText="Texture saved, 256x"+STR$(TextureHeight)+" pixels."
Form1.Show

IF CurrentType=4 THEN
Status1.SimpleText="Writing sprite..."
Form1.Show
'Form1.ClientWidth = 256
'Form1.ClientHeight = 256+24
' SpriteCanvas.Width = 256
' SpriteCanvas.Height = 128
' SpriteCanvas.ClientWidth = 128
' SpriteCanvas.ClientHeight = 128
' SpriteBitMap.Width = 128
' SpriteBitMap.Height = 128
'Form1.Center
 File.SaveArray(Sprite(0, 0),128*128)
Status1.SimpleText="Sprite saved."
Form1.Show
' InitScreen
' StoreBitmap(0)

END IF

IF CurrentType<>2 THEN

IF AniCount>0 THEN 
FOR A1 = 1 TO AniCount
Status1.SimpleText="Writing Animation: "+STR$(A1)
Form1.Show
IF CurrentType<2 THEN
TMPaniName=AnimList(A1-1).aniName
File.WriteBinStr(TMPaniName,32)
Status1.SimpleText="Animation "+STR$(A1)+" Name: "+TMPaniName
Form1.Show
END IF
IF CurrentType>2 THEN
File.Write(TMPvCount1)
File.Write(TMPvCount2)
END IF
TMPaniKPS=AnimList(A1-1).aniKPS
File.Write(TMPaniKPS)
Status1.SimpleText="Animation "+STR$(A1)+" KPS: "+STR$(TMPaniKPS)
Form1.Show
TMPFramesCount=AnimList(A1-1).FramesCount
File.Write(TMPFramesCount)
IF CurrentType>2 THEN TMPFramesCount++
Status1.SimpleText="Animation "+STR$(A1)+" Frames: "+STR$(TMPFramesCount)
Form1.Show
 FOR Frame=1 to TMPFramesCount
  FOR Vertex=1 TO VCount
   FOR Coord=1 TO 3
    TMPaniCoord=AnimData(A1-1,Frame-1,Vertex-1,Coord-1)
    File.Write(TMPaniCoord)
   NEXT Coord
'  Status1.SimpleText="Data "+STR$(A1)+","+STR$(Frame)+","+STR$(Vertex)+"="+STR$(AnimData(A1-1,Frame-1,Vertex-1,0))+","+STR$(AnimData(A1-1,Frame-1,Vertex-1,1))+","+STR$(AnimData(A1-1,Frame-1,Vertex-1,2))
  NEXT Vertex
 NEXT Frame
NEXT A1

ShowAnimList.Enabled=True
END IF

END IF

IF CurrentType=1 THEN

IF SfxCount>0 THEN

FOR A1 = 1 TO SfxCount
Status1.SimpleText="Writing Sound: "+STR$(A1)
Form1.Show
TMPsfxName=SoundList(A1-1).sfxName
File.WriteBinStr(TMPsfxName,32)
Status1.SimpleText="Sound "+STR$(A1)+" Name: "+TMPsfxName
Form1.Show
TMPlength=SoundList(A1-1).length
File.Write(TMPlength)
Status1.SimpleText="Sound "+STR$(A1)+" length: "+STR$(TMPlength)+" bytes"
Form1.Show
TMPlpData = SoundList(A1-1).lpData
File.WriteBinStr(TMPlpData, TMPlength)
'play (TMPlength, TMPlpData)
NEXT A1

    File.SaveArray(AniFX(0),64)
    Status1.SimpleText="Sound table saved."
    Form1.Show
    
    SfxMenu.Enabled=True
    SfxSelect.Enabled=True
    ShowSfxList.Enabled=True
        ShowTable.Enabled=True
    
END IF
END IF

    Status1.SimpleText=FileName$+" saved OK."
File.Close
END SUB

SUB File3dfExport
  
  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "3DF Files (*.3df)|*.3df"

  IF SaveDialog.Execute THEN
    FileType=SaveDialog.FilterIndex
    FileName$=SaveDialog.FileName
  IF INSTR(LCASE$(FileName$),".3df") = 0 THEN FileName$=FileName$+".3df"
    Status1.SimpleText="Exporting as "+FileName$
    Save3dfFile
'    ShowMenu.Enabled=True
   END IF
END SUB

SUB Save3dfFile

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Status1.SimpleText="Writing Header Data..."
Form1.Show

File.Write(VCount)
Status1.SimpleText="Vertices: "+STR$(VCount)
Form1.Show

File.Write(FCount)
Status1.SimpleText="Faces: "+STR$(FCount)
Form1.Show

File.Write(OCount)
Status1.SimpleText="Objects: "+STR$(OCount)
Form1.Show

File.Write(TextureSize)
Status1.SimpleText="Texture size: "+STR$(TextureSize)+" Bytes (256x"+STR$(TextureHeight)+" pixels)"
Form1.Show

FOR A1 = 1 TO FCount
Status1.SimpleText="Writing Face: "+STR$(A1)
Form1.Show
File.WriteUDT(FaceList(A1 - 1))
NEXT A1

FOR A1 = 1 TO VCount
Status1.SimpleText="Writing Vertex: "+STR$(A1)
Form1.Show
File.WriteUDT(PointList(A1 - 1))
NEXT A1

FOR A1 = 1 TO OCount
Status1.SimpleText="Writing Object: "+STR$(A1)
Form1.Show
File.WriteUDT(ObjList(A1 - 1))
NEXT A1

Status1.SimpleText="Writing texture..."
Form1.Show
'Form1.Center
File.SaveArray(Texture(0, 0),256*TextureHeight)
Status1.SimpleText="Texture saved, 256x"+STR$(TextureHeight)+" pixels."
Form1.Show

    Status1.SimpleText="Mesh exported successfully as "+FileName$+"."
File.Close
END SUB

SUB FileMdfExport
  
  SaveDialog.InitialDir = CurDir$
  SaveDialog.Mode=fdSave
  SaveDialog.WarnIfOverwrite=1
  SaveDialog.Filter = "Model Description Files (*.mdf)|*.mdf"

  IF SaveDialog.Execute THEN
    FileType=SaveDialog.FilterIndex
    FileName$=SaveDialog.FileName
  IF INSTR(LCASE$(FileName$),".mdf") = 0 THEN FileName$=FileName$+".mdf"
    Status1.SimpleText="Exporting as "+FileName$
    SaveMdfFile
'    ShowMenu.Enabled=True
   END IF
END SUB

SUB SaveMdfFile

DIM File AS QFileStream
File.Open(FileName$, fmCreate)
Status1.SimpleText="Writing Header Data..."
Form1.Show
File.Write("3df model description. Version=1."+LF)

File.Write("Total vertex="+STR$(VCount)+LF)
Status1.SimpleText="Vertices: "+STR$(VCount)
Form1.Show

File.Write("Total face="+STR$(FCount)+LF)
Status1.SimpleText="Faces: "+STR$(FCount)
Form1.Show

File.Write("Total object="+STR$(OCount)+LF)
Status1.SimpleText="Objects: "+STR$(OCount)
Form1.Show

File.Write(LF)
File.Write("### Vertex description. <X Y Z owner hide>"+LF)
FOR A1 = 0 TO VCount-1
Status1.SimpleText="Writing Vertex: "+STR$(A1+1)
Form1.Show
File.Write(STR$(PointList(A1).x)+" "+STR$(PointList(A1).y)+" "+STR$(PointList(A1).z)+" "+STR$(PointList(A1).owner)+" "+STR$(PointList(A1).hide)+LF)
NEXT A1

File.Write(LF)
File.Write("### Face description. <V1 V2 V3 (tax tay) (tbx tby) (tcx tcy) flags group texture>"+LF)
FOR A1 = 0 TO FCount-1
Status1.SimpleText="Writing Face: "+STR$(A1+1)
Form1.Show
File.Write(STR$(FaceList(A1).v1)+" "+STR$(FaceList(A1).v2)+" "+STR$(FaceList(A1).v3))
File.Write(" ("+STR$(FaceList(A1).tax)+" "+STR$(FaceList(A1).tay)+") ("+STR$(FaceList(A1).tbx)+" "+STR$(FaceList(A1).tby)+") ("+STR$(FaceList(A1).tcx)+" "+STR$(FaceList(A1).tcy)+") ")
File.Write(STR$(FaceList(A1).Flags)+" "+STR$(FaceList(A1).group)+" 0"+LF)
NEXT A1

File.Write(LF)
File.Write("### Object description. <name X Y Z owner hide>"+LF)
FOR A1 = 0 TO OCount-1
Status1.SimpleText="Writing Object: "+STR$(A1+1)
Form1.Show

File.Write(LEFT$(ObjList(A1).objName, INSTR(ObjList(A1).objName, CHR$(0)) -1))
File.Write(" "+STR$(ObjList(A1).ox)+" "+STR$(ObjList(A1).oy)+" "+STR$(ObjList(A1).oz)+" "+STR$(ObjList(A1).owner)+" "+STR$(ObjList(A1).hide)+LF)
NEXT A1

    Status1.SimpleText="Mesh exported successfully as "+FileName$+"."
File.Close
END SUB


sub meshframe(state as integer, ox as integer, nx as integer, oy as integer, ny as integer)
    dx = ox - nx
    dy = ny - oy
    select case state
      case PAN:    trans(0) = trans(0) - dx
                   trans(1) = trans(1) - dy
      case ROTATE: rotat(0) = rotat(0) + (dy * 18.0) / 10.0
                   rotat(1) = rotat(1) - (dx * 18.0) / 10.0
      case ZOOM:   trans(2) = trans(2) - (dx + dy) 
    end select
end sub

sub setrendermode
    	'' All Setup For OpenGL Goes Here 
	glEnable GL_TEXTURE_2D                         '' Enable Texture Mapping ( NEW ) 
    glEnable(GL_DEPTH_TEST)
    glDepthFunc(GL_LEQUAL)
    glEnable (GL_CULL_FACE)
    glCullFace (GL_FRONT)
end sub

sub setvisual(iw as integer, ih as integer)
    defdbl aspect = iw/ih
    glViewport(0, 0, iw, ih)
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity
    gluPerspective(60.0,aspect,0.1,3000.0)
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity
    glTranslatef(0.0, 0.0, -100.0)
end sub

sub meshbuilder
    ' rotate a triangle around 
'     glMatrixMode (GL_MODELVIEW)
 
    glPushMatrix
'    CheckProj
    glTranslatef(trans(0), trans(1), trans(2))
    glRotatef(rotat(0), 1.0, 0.0, 0.0)
    glRotatef(rotat(1), 0.0, 1.0, 0.0)
        glClearColor(0.5,0.5,0.5,0.0)
        glClearDepth(1.0)
    glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT)
'        glPolygonMode(GL_FRONT_AND_BACK, GL_FILL)
'        glDisable(GL_CULL_FACE)
 	glBindTexture GL_TEXTURE_2D, myTexture                 '' Select new Texture if needed 
'	glEnable GL_TEXTURE_2D                         '' Enable Texture Mapping ( NEW ) 

	glDisable GL_TEXTURE_2D                         '' Enable Texture Mapping ( NEW ) 
        glDisable GL_BLEND
  glDisable(GL_ALPHA_TEST)
        glDisable(GL_CULL_FACE)

 
        glPolygonMode(GL_FRONT_AND_BACK, GL_LINE)
 glColor3f(0.0,0.0,0.0)
IF CurrentType>2 THEN
   glPushMatrix
      glTranslatef( 0, 0, 0 )'' translate to origin
      glRotatef(-90, 1, 0, 0.0)'' Rotate about rotation vector
      IF ViewSphere.Checked THEN gluSphere(sphere, ObjInfo.BoundR, 8, 8)'' draw sphere
      IF ViewCirc.Checked THEN gluDisk( disk, 0.0, ObjInfo.GrRad, 8, 1)'' draw circle
   glPopMatrix
   glPushMatrix
      glTranslatef( 0, ObjInfo.YLo, 0 )'' translate to cylinder base
      glRotatef(-90, 1, 0, 0.0)'' Rotate about rotation vector
      IF ViewCyl.Checked THEN gluCylinder(cyl, ObjInfo.Radius, ObjInfo.Radius, ObjInfo.YHi-ObjInfo.YLo, 8, 1)'' draw cylinder
   glPopMatrix
END IF
   
 glColor3f(1.0,1.0,0.0)
IF ViewGridXY0.Checked = 0 THEN glCallList(gridList)
 glColor3f(1.0,0.0,1.0)
IF ViewGridXZ0.Checked = 0 THEN glCallList(gridList+1)
 glColor3f(0.0,1.0,1.0)
IF ViewGridYZ0.Checked = 0 THEN glCallList(gridList+2)
        glEnable(GL_CULL_FACE)

IF ViewAxes.Checked THEN glCallList(meshList)
IF ViewWire.Checked THEN
        glPolygonMode(GL_FRONT_AND_BACK, GL_LINE)
ELSE
        glPolygonMode(GL_FRONT_AND_BACK, GL_FILL)
END IF
        
IF ViewTexd.Checked THEN
	glEnable GL_TEXTURE_2D                         '' Enable Texture Mapping ( NEW ) 
        glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE)
END IF        
IF Index3>0 THEN glCallList(meshList+3) ' none
        glDisable(GL_CULL_FACE)
IF Index6>0 THEN glCallList(meshList+6) ' sfDoubleSide
        glEnable(GL_CULL_FACE)
'  glEnable(GL_ALPHA_TEST)
'  glAlphaFunc(GL_GREATER, 0.5)
        glEnable GL_BLEND
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA)
'    glBlendFunc(GL_SRC_COLOR,GL_ONE_MINUS_SRC_COLOR)
'    glBlendFunc(GL_ONE_MINUS_SRC_ALPHA,GL_SRC_ALPHA)
'    glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_COLOR)
IF Index2>0 THEN glCallList(meshList+2) ' sfOpacity
        glDisable(GL_CULL_FACE)
IF Index5>0 THEN glCallList(meshList+5) ' sfDoubleSide
        glEnable(GL_CULL_FACE)
'  glDisable(GL_ALPHA_TEST)
'  glEnable GL_BLEND
'    glBlendFunc(GL_SRC_COLOR,GL_ONE_MINUS_SRC_COLOR)
'    glBlendFunc(GL_SRC_COLOR,GL_ONE)
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA)
IF Index1>0 THEN glCallList(meshList+1) ' sfTransparent
        glDisable(GL_CULL_FACE)
IF Index4>0 THEN glCallList(meshList+4) ' sfDoubleSide
        glEnable(GL_CULL_FACE)
 glDisable GL_BLEND
IF ViewMortal.Checked AND Index7>0 THEN
        glEnable GL_BLEND
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA)
glCallList(meshList+7) ' sfMortal
 glDisable GL_BLEND
END IF        
 IF ViewSubObjs.Checked THEN
        glEnable GL_BLEND
        glDisable(GL_CULL_FACE)
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA)
     glCallList(suboList+ObjIndex)
        glEnable(GL_CULL_FACE)
 glDisable GL_BLEND
 END IF        

 IF ViewTris.Checked THEN
        glEnable GL_BLEND
        glDisable(GL_CULL_FACE)
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA)

' DIM V1 AS INTEGER, V2 AS INTEGER, V3 AS INTEGER
' V1=FaceList(TriIndex).v1
' V2=FaceList(TriIndex).v2
' V3=FaceList(TriIndex).v3
     glCallList(trisList)
     glBegin(GL_TRIANGLES)
     glColor4f(1.0, 0.0, 1.0, 0.75)
     glVertex3f(-PointList(FaceList(TriIndex).v1).x,PointList(FaceList(TriIndex).v1).y,PointList(FaceList(TriIndex).v1).z)
     glColor4f(1.0, 0.0, 1.0, 0.75)
     glVertex3f(-PointList(FaceList(TriIndex).v2).x,PointList(FaceList(TriIndex).v2).y,PointList(FaceList(TriIndex).v2).z)
     glColor4f(1.0, 0.0, 1.0, 0.75)
     glVertex3f(-PointList(FaceList(TriIndex).v3).x,PointList(FaceList(TriIndex).v3).y,PointList(FaceList(TriIndex).v3).z)
    glEnd

        glEnable(GL_CULL_FACE)
 glDisable GL_BLEND
 END IF        

IF ViewTexd.Checked THEN
	glDisable GL_TEXTURE_2D                         '' Enable Texture Mapping ( NEW ) 
END IF
IF ViewWire.Checked THEN
        glPolygonMode(GL_FRONT_AND_BACK, GL_FILL)
ELSE
        glPolygonMode(GL_FRONT_AND_BACK, GL_LINE)
END IF

    glPopMatrix
'    glMatrixMode (GL_MODELVIEW)
    GL.Flip
end sub


SUB FormMouseDown (Button%, X%, Y%, Shift%) 
  if Button% = 0 then state = ROTATE  'or state 
  if Button%= 1 then state = PAN 'or state 
  if Button%= 2 then state = ZOOM 'or state 
  mx = X%'Screen.mouseX 
  my = Y%'Screen.mouseY 
END SUB

SUB FormMouseUp(Button%, X%, Y%, Shift%)
   state = 0
END SUB

SUB FormMouseWheel (Rotation%, X%, Y%, Shift%)
'Showmessage "mouse rotated at " + str$(X%) + "  " + str$(Y%) + "  " + str$(Shift%) 
    state=ZOOM
  meshframe(state,0,Rotation%,0,Rotation%)
     meshbuilder
     GL.Flip
END SUB

SUB FormMouseMove (X%, Y%, Shift%)
     meshframe(state, mx, X%, my, Y%)
     mx = X%
     my = y%
     meshbuilder
     GL.Flip
END SUB

SUB FormKeyDown (Key AS Word, KeyShift AS INTEGER) 
  if key = 27 then 
'    GL.Close
    Form.close
  end if
'  if KeyShift THEN state = STATE XOR ZOOM
  SELECT CASE Key
  CASE 33 ' Page Up
  state = ZOOM
  meshframe(state,0,2,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 34 ' Page Down
  state = ZOOM
  meshframe(state,2,0,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 37 ' Left Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,2,0,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 38 ' Up Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,0,2,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 39 ' Right Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,2,0,0)
     meshbuilder
  state = 0
     GL.Flip
  CASE 40 ' Down Arrow
  state = ROTATE
  if KeyShift THEN state = PAN
  meshframe(state,0,0,0,2)
     meshbuilder
  state = 0
     GL.Flip
  CASE ELSE
  state = 0
  meshframe(state,0,0,0,0)
     meshbuilder
     GL.Flip
  END SELECT
END SUB


SUB FormSize
  GL.Resize(form.clientWidth, form.clientHeight)
  setvisual(GL.width, GL.height)
'  setvisual(256, 256)
  meshbuilder
END SUB
 
SUB ViewMesh
FormSize
 Form.Show
    Form.Left=Form1.Left+264
    Form.Top=Form1.Top
'    Form.Visible=True
SetFocus(Form.handle)
END SUB

 
SUB FormCreate
    GL.Init(form)
   setrendermode
END SUB

SUB FormClose
    Form.close
END SUB

SUB ToggleMortal
ViewMortal.Checked = 1-(ViewMortal.Checked)
meshbuilder
END SUB

SUB ToggleAxes
ViewAxes.Checked = 1-(ViewAxes.Checked)
meshbuilder
END SUB

SUB ToggleWire
ViewWire.Checked = True
meshbuilder
END SUB

SUB ToggleTexd
ViewTexd.Checked = True
meshbuilder
END SUB

SUB ToggleGridXY (Sender AS QMENUITEM)
Sender.Checked = True
SELECT CASE Sender.MenuIndex
CASE 1
InitGridXY(1)
CASE 2
InitGridXY(10)
CASE 3
InitGridXY(100)
END SELECT
meshbuilder
END SUB

SUB ToggleGridXZ (Sender AS QMENUITEM)
Sender.Checked = True
SELECT CASE Sender.MenuIndex
CASE 1
InitGridXZ(1)
CASE 2
InitGridXZ(10)
CASE 3
InitGridXZ(100)
END SELECT
meshbuilder
END SUB

SUB ToggleGridYZ (Sender AS QMENUITEM)
Sender.Checked = True
SELECT CASE Sender.MenuIndex
CASE 1
InitGridYZ(1)
CASE 2
InitGridYZ(10)
CASE 3
InitGridYZ(100)
END SELECT
meshbuilder
END SUB

SUB ToggleCyl
ViewCyl.Checked = 1-(ViewCyl.Checked)
meshbuilder
END SUB

SUB ToggleCirc
ViewCirc.Checked = 1-(ViewCirc.Checked)
meshbuilder
END SUB

SUB ToggleSphere
ViewSphere.Checked = 1-(ViewSphere.Checked)
meshbuilder
END SUB

SUB ToggleOrtho
ViewOrtho.Checked = True
    meshbuilder
END SUB

SUB TogglePers
ViewPers.Checked = True
    meshbuilder
END SUB

SUB CheckProj
IF ViewOrtho.Checked THEN
    glMatrixMode GL_PROJECTION
    glLoadIdentity
' IF ViewPers.Checked THEN
' gluPerspective(60.0,aspect,0.1,3000.0)
' ELSE
 glOrtho(-Form.width/2,Form.width/2,-Form.height/2,Form.height/2,0.1,3000.0)
    glMatrixMode GL_MODELVIEW
    glLoadIdentity
END IF
END SUB

SUB ObjNumberChange
    ObjIndex=ObjScrollSelect.Position
    ObjLabelNum0.Caption = STR$(ObjIndex)
DIM TMPobjName AS STRING * 32
DIM TMPx AS SINGLE, TMPy AS SINGLE, TMPz AS SINGLE
DIM TMPowner AS SHORT, TMPhide AS SHORT
        TMPobjName=ObjList(ObjIndex).objName
        SubObjNameValue.Caption = LEFT$(TMPobjName, INSTR(TMPobjName, CHR$(0)) -1)
        TMPx=ObjList(ObjIndex).ox
        TMPy=ObjList(ObjIndex).oy
        TMPz=ObjList(ObjIndex).oz
        SubObjCenterValue.Caption = STR$(TMPx)+", "+STR$(TMPy)+", "+STR$(TMPz)
        TMPowner=ObjList(ObjIndex).owner
        TMPhide=ObjList(ObjIndex).hide
        SubObjOwnerValue.Caption = STR$(TMPowner)
        SubObjHideValue.Caption = STR$(TMPhide)
    meshbuilder
END SUB

SUB OpenObjForm
    ViewSubObjs.Checked = True
    ObjScrollSelect.Position=ObjIndex
    ObjForm.Visible=True
    ObjForm.Show
    ObjNumberChange
    meshbuilder
END SUB

SUB CloseObjForm
    ViewSubObjs.Checked = False
    ObjIndex = 0
    meshbuilder
END SUB

SUB SfxNumberChange
    SfxIndex=SfxScrollSelect.Position
    SfxLabelNum0.Caption = STR$(SfxIndex)
    SfxLabelName.Caption = SoundList(SfxIndex).sfxName
END SUB

SUB EditSfxForm
    SfxScrollSelect.Position=SfxIndex
    SfxForm.Visible=True
END SUB

SUB CloseSfxForm
    SfxForm.Close
END SUB

SUB AnimNumberChange
    AnimIndex=AnimScrollSelect.Position
    AnimLabelNum0.Caption = STR$(AnimIndex)
    AnimLabelName.Caption = AnimList(AnimIndex).aniName
    AnimSfxScrollSelect.Position = AniFX(AnimIndex)
END SUB

SUB AnimSfxNumberChange
    AnimSfxIndex=AnimSfxScrollSelect.Position
    AniFX(AnimIndex) = AnimSfxIndex
    AnimSfxLabelNum0.Caption = STR$(AnimSfxIndex)
    IF AnimSfxIndex < 0 THEN AnimSfxLabelName.Caption = "None" ELSE AnimSfxLabelName.Caption = SoundList(AnimSfxIndex).sfxName
END SUB

SUB EditAnimForm
    AnimScrollSelect.Position=AnimIndex
    AnimForm.Visible=True
    AnimSfxScrollSelect.Max = SfxCount-1
    AnimSfxScrollSelect.Position = AniFX(AnimIndex)
    AnimSfxLabelNum0.Caption = STR$(AniFX(AnimIndex))
    IF AniFX(AnimIndex) < 0 THEN AnimSfxLabelName.Caption = "None" ELSE AnimSfxLabelName.Caption = SoundList(AniFX(AnimIndex)).sfxName

END SUB

SUB CloseAnimForm
    AnimForm.Close
END SUB

SUB TriNumberChange
    TriIndex=TriScrollSelect.Position
    TriLabelNum0.Caption = STR$(TriIndex)
DIM TMPflags AS WORD, TMPdmask AS WORD
DIM TMPdistant as INTEGER, TMPnext AS INTEGER, TMPgroup AS INTEGER
        TMPflags=FaceList(TriIndex).Flags
        TMPdmask=FaceList(TriIndex).DMask
        TMPdistant=FaceList(TriIndex).Distant
        TMPnext=FaceList(TriIndex).FaceNext
        TMPgroup=FaceList(TriIndex).group
                TriDMaskValue.Caption = STR$(TMPdmask)
        TriDistantValue.Caption = STR$(TMPdistant)
        TriNextValue.Caption = STR$(TMPnext)
        TriGroupValue.Caption = STR$(TMPgroup)
        TriDoubleSide.Checked = SGN(TMPflags AND sfDoubleSide)
        TriDarkBack.Checked = SGN(TMPflags AND sfDarkBack)
        TriOpacity.Checked = SGN(TMPflags AND sfOpacity)
        TriTransparent.Checked = SGN(TMPflags AND sfTransparent)
        TriMortal.Checked = SGN(TMPflags AND sfMortal)
        TriPhong.Checked = SGN(TMPflags AND sfPhong)
        TriEnvMap.Checked = SGN(TMPflags AND sfEnvMap)
        TriNeedVC.Checked = SGN(TMPflags AND sfNeedVC)
        TriDark.Checked = SGN(TMPflags AND sfDark)
        
    meshbuilder
END SUB

SUB OpenTriForm
    ViewTris.Checked = True
    TriScrollSelect.Position=TriIndex
    TriForm.Visible=True
    TriForm.Show
    TriNumberChange
    meshbuilder
END SUB

SUB CloseTriForm
    ViewTris.Checked = False
    TriIndex = 0
    meshbuilder
END SUB

SUB SaveTriForm
DIM TMPflags AS WORD
TMPflags = 0
        TMPflags = TMPflags+TriDoubleSide.Checked * sfDoubleSide
        TMPflags = TMPflags+TriDarkBack.Checked * sfDarkBack
        TMPflags = TMPflags+TriOpacity.Checked * sfOpacity
        TMPflags = TMPflags+TriTransparent.Checked * sfTransparent
        TMPflags = TMPflags+TriMortal.Checked * sfMortal
        TMPflags = TMPflags+TriPhong.Checked * sfPhong
        TMPflags = TMPflags+TriEnvMap.Checked * sfEnvMap
        TMPflags = TMPflags+TriNeedVC.Checked * sfNeedVC
        TMPflags = TMPflags+TriDark.Checked * sfDark
TriIndex=TriScrollSelect.Position
FaceList(TriIndex).Flags=TMPflags

ReInitLists
InitMesh
meshbuilder
END SUB

SUB AllTriForm
DIM TMPflags AS WORD
TMPflags = 0
        TMPflags = TMPflags+TriDoubleSide.Checked * sfDoubleSide
        TMPflags = TMPflags+TriDarkBack.Checked * sfDarkBack
        TMPflags = TMPflags+TriOpacity.Checked * sfOpacity
        TMPflags = TMPflags+TriTransparent.Checked * sfTransparent
        TMPflags = TMPflags+TriMortal.Checked * sfMortal
        TMPflags = TMPflags+TriPhong.Checked * sfPhong
        TMPflags = TMPflags+TriEnvMap.Checked * sfEnvMap
        TMPflags = TMPflags+TriNeedVC.Checked * sfNeedVC
        TMPflags = TMPflags+TriDark.Checked * sfDark
TriIndex=TriScrollSelect.Position
    FOR A1 = 0 TO FCount-1
    FaceList(A1).Flags=TMPflags
    NEXT A1

ReInitLists
InitMesh
meshbuilder
END SUB

SUB TriFormClose
    TriForm.Close
END SUB

SUB AddToList
    TriList(TriIndex) = 1
    InitList
    meshbuilder
END SUB

SUB RemoveFromList
    TriList(TriIndex) = 0
    InitList
    meshbuilder
END SUB

SUB ClearList
    MEMSET(TriListAddr,0,1024*SIZEOF(BYTE))
    InitList
    meshbuilder
END SUB

SUB FillList
    MEMSET(TriListAddr,1,1024*SIZEOF(BYTE))
    InitList
    meshbuilder
END SUB

SUB CopyToList
    DIM TMPflags AS WORD
    TMPflags=FaceList(TriIndex).Flags
    FOR A1 = 0 TO FCount-1
        IF TriList(A1) = 1 THEN FaceList(A1).Flags=TMPflags
    NEXT A1
    ReInitLists
    InitMesh
    InitList
    meshbuilder
END SUB

SUB ReInitLists
Index1 = 0: Index2 = 0: Index3 = 0
Index4 = 0: Index5 = 0: Index6 = 0
Index7 = 0
FOR A1 = 0 TO FCount -1
TMPFlags=FaceList(A1).Flags
IF (TMPFlags AND sfMortal) THEN  List7(Index7) = A1: Index7++
IF (TMPFlags AND sfTransparent) THEN
 IF (TMPFlags AND sfDoubleSide) THEN
  List4(Index4) = A1: Index4++
 ELSE
  List1(Index1) = A1: Index1++
 END IF
ELSE
 IF (TMPFlags AND sfOpacity) THEN
  IF (TMPFlags AND sfDoubleSide) THEN
   List5(Index5) = A1: Index5++
  ELSE
   List2(Index2) = A1: Index2++
  END IF
 ELSE
  IF (TMPFlags AND sfDoubleSide) THEN
   List6(Index6) = A1: Index6++
     ELSE
   List3(Index3) = A1: Index3++
  END IF
 END IF
END IF

NEXT A1
END SUB
